#!/bin/sh

# ******************************************************************************
#
#  (C) 2018 AhnLab, Inc. All rights reserved.
#  Any part of this source code can not be copied with any method without
#  prior written permission from the author or authorized person.
#
# ******************************************************************************

export OS
INSTALL_PATH="`cat /etc/v3dl.install.conf | grep InstallPath | cut -c 13-`"

# includes util.sh to log
export LOG_FILE_NAME
LOG_FILE_NAME=`basename ${0}`
. ${INSTALL_PATH}/bin/util.sh

OS=""
UNAME=`uname`
case "$UNAME" in
	HP-UX)
		OS="hpux"
		;;  
	SunOS)
		if test `uname -i` = "i86pc"; then
			OS="solx86"
		else
			OS="solaris"
		fi  
		;;  
	FreeBSD)
		OS="freebsd"
		;;  
	Linux)
		if test `uname -m` = "i686"; then
			OS="linux_i686"
		else
			OS="linux_x86_64"
		fi
		;;
	AIX)
		OS="aix"
		;;  
esac

print_log "System : `uname -a`"

BUFFER=`grep ApcSerial ./conf/v3dld.conf`

if [ "$BUFFER" = "" ]; then
	echo "ApcSerial=" >> ./conf/v3dld.conf
fi