#!/bin/sh

# ******************************************************************************
#
#  (C) 2018 AhnLab, Inc. All rights reserved.
#  Any part of this source code can not be copied with any method without
#  prior written permission from the author or authorized person.
#
# ******************************************************************************

# 'LOG_FILE_NAME' was set by caller shell script (ex, v3net.sh , watchdog.sh, ... )

RED='\033[1;31m'
GR='\033[1;32m'
NC='\033[0m'

# log format : [YYYY-MM-DD HH:MM:SS]
check_log_dir() {
        if [ ! -d $INSTALL_PATH/log ]; then 
                mkdir $INSTALL_PATH/log
                chmod 750 $INSTALL_PATH/log
        fi   
}

print_log() {
        check_log_dir

        LOG_DATE=`date +%Y%m%d`
        SLF="$INSTALL_PATH/log/${LOG_FILE_NAME}_${LOG_DATE}.log"
        DATE=`date +%Y-%m-%d`
        TIME=`date +%H:%M:%S`

        if [ ! -d "$INSTALL_PATH/log" ]; then
 	        mkdir -m 750 "$INSTALL_PATH/log"
 	fi

        echo "[${DATE} ${TIME}] ${GR}[NORMAL]${NC} ${1}" >> ${SLF}

        chmod 640 ${SLF}
}

# for print log at WATCHDOG LOG from v3ll.sh script
print_watchdog_log() {
        LOG_DATE=`date +%Y%m%d`
        SLF="$INSTALL_PATH/log/${WATCHDOG_LOG_FILE_NAME}_${LOG_DATE}.log"
        DATE=`date +%Y-%m-%d`
        TIME=`date +%H:%M:%S`

        if [ ! -d "$INSTALL_PATH/log" ]; then
 	        mkdir -m 750 "$INSTALL_PATH/log"
 	fi

        echo "[${DATE} ${TIME}] ${GR}[NORMAL]${NC} ${1}" >> ${SLF}

        chmod 640 ${SLF}
}

# log format : [YYYY-MM-DD HH:MM:SS] [ERROR]
error_log() {
        check_log_dir
        LOG_DATE=`date +%Y%m%d`
        SLF="$INSTALL_PATH/log/${LOG_FILE_NAME}_${LOG_DATE}.log"
        DATE=`date +%Y-%m-%d`
        TIME=`date +%H:%M:%S`
        if [ ! -d "$INSTALL_PATH/log" ]; then
 	        mkdir -m 750 "$INSTALL_PATH/log"
 	fi
        echo "[${DATE} ${TIME}] ${RED}[ERROR]${NC}  ${1}" >> ${SLF}
        chmod 640 ${SLF}
}

# echo with 'print_log'
echo_print() {
        echo "${1}"
        print_log "${1}"
}

# echo with 'error_log'
echo_error() {
        echo "${1}"
        error_log "${1}"
}
