<?php
inc_func(g_inc_type_inc, "filescan_socket");

class protocalCls extends socketCls
{
    private $packet_head = "#";
    private $packet_type = array("COMMAND_NONE" => 0
                                ,"COMMAND_SCAN_START_REQ"    => 1 ,"COMMAND_SCAN_START_REP"    => 2
                                ,"COMMAND_SCAN_STOP_REQ"     => 3 ,"COMMAND_SCAN_STOP_REP"     => 4
                                ,"COMMAND_SCAN_PAUSE_REQ"    => 5 ,"COMMAND_SCAN_PAUSE_REP"    => 6
                                ,"COMMAND_SCAN_RESTART_REQ"  => 7 ,"COMMAND_SCAN_RESTART_REP"  => 8
                                ,"COMMAND_SCAN_DIR_REQ"      => 9 ,"COMMAND_SCAN_DIR_REP"      => 10
                                ,"COMMAND_SCAN_STATUS_REQ"   => 11,"COMMAND_SCAN_STATUS_REP"   => 12
                                ,"COMMAND_SCAN_RESULT_REQ"   => 13,"COMMAND_SCAN_RESULT_REP"   => 14
                                ,"COMMAND_LOW_DIR_REQ"       => 15,"COMMAND_LOW_DIR_REP"       => 16
                                ,"COMMAND_CURE_START_REQ"    => 17,"COMMAND_CURE_START_REP"    => 18
                                ,"COMMAND_CURE_STOP_REQ"     => 19,"COMMAND_CURE_STOP_REP"     => 20
                                ,"COMMAND_CURE_RESULT_REQ"   => 21,"COMMAND_CURE_RESULT_REP"   => 22

                                ,"COMMAND_SUPDATE_START_REQ"      => 31,"COMMAND_SUPDATE_START_REP"     => 32
                                ,"COMMAND_SUPDATE_STOP_REQ"       => 33,"COMMAND_SUPDATE_STOP_REP"      => 34
                                ,"COMMAND_SUPDATE_STATUS_REQ"     => 35,"COMMAND_SUPDATE_STATUS_REP"    => 36
                                ,"COMMAND_SUPDATE_FILE_REQ"       => 37,"COMMAND_SUPDATE_FILE_REP"      => 38
                                ,"COMMAND_SUPDATE_AUTOCOPY_REQ"   => 39,"COMMAND_SUPDATE_AUTOCOPY_REP"  => 40

                                ,"COMMAND_MANAGER_AUTO_START_REQ"         => 41,"COMMAND_MANAGER_AUTO_START_REP"         => 42
                                ,"COMMAND_MANAGER_CHANGE_SERVER_INFO_REQ" => 43,"COMMAND_MANAGER_CHANGE_SERVER_INFO_REP" => 44

                                ,"COMMAND_EVENT_LOG_REQ"               => 61,"COMMAND_EVENT_LOG_REP"                => 62
                                ,"COMMAND_QUARANTINE_RESTORE_REQ"      => 81,"COMMAND_QUARANTINE_RESTORE_REP"       => 82

                                ,"COMMAND_CONFIG_UPDATE_PROXY_SET_REQ" => 130,"COMMAND_CONFIG_UPDATE_PROXY_SET_REP" => 131

                                ,"COMMAND_CONFIG_SET_EULA_REQ" => 132,"COMMAND_CONFIG_SET_EULA_REP" => 133
                                );

    private $packet_read_byte = array("COMMAND_SCAN_START_REP"          => 4
                                      ,"COMMAND_SCAN_STOP_REP"          => 4
                                      ,"COMMAND_SCAN_PAUSE_REP"         => 4
                                      ,"COMMAND_SCAN_RESTART_REP"       => 4
                                      ,"COMMAND_SCAN_DIR_REP"           => -1
                                      ,"COMMAND_SCAN_STATUS_REP"        => -1
                                      ,"COMMAND_SCAN_RESULT_REP"        => -1
                                      ,"COMMAND_LOW_DIR_REP"            => -1
                                      ,"COMMAND_CURE_START_REP"         => 4
                                      ,"COMMAND_CURE_STOP_REP"          => 4
                                      ,"COMMAND_CURE_RESULT_REP"        => -1

                                      ,"COMMAND_SUPDATE_START_REP"      => 4
                                      ,"COMMAND_SUPDATE_STOP_REP"       => 4
                                      ,"COMMAND_SUPDATE_STATUS_REP"     => 4
                                      ,"COMMAND_SUPDATE_FILE_REP"       => -1
                                      ,"COMMAND_SUPDATE_AUTOCOPY_REP"   => 4
                                      ,"COMMAND_APC_SCAN_START_REP"     => 4
                                      ,"COMMAND_APC_RESERVE_INSERT_REP" => 4

                                      ,"COMMAND_MANAGER_AUTO_START_REP"         => 4
                                      ,"COMMAND_MANAGER_CHANGE_SERVER_INFO_REP" => 4

                                      ,"COMMAND_EVENT_LOG_REP"           => -1

                                      ,"COMMAND_CONFIG_UPDATE_PROXY_SET_REP"  => -1

                                      );

    private $res_body_type = array("COMMAND_SCAN_START_REP"             => "istatus"
                                  ,"COMMAND_SCAN_STOP_REP"              => "istatus"
                                  ,"COMMAND_SCAN_PAUSE_REP"             => "istatus"
                                  ,"COMMAND_SCAN_RESTART_REP"           => "istatus"
                                  ,"COMMAND_SCAN_DIR_REP"               => "idircnt/istatus/iprogress/a*dir"
                                  ,"COMMAND_SCAN_STATUS_REP"            => "itype/istatus"
                                  ,"COMMAND_SCAN_RESULT_REP"            => "iinfetcnt/icurecnt/ilistcnt/a*scanlist"
                                  ,"COMMAND_LOW_DIR_REP"                => "idircnt/a*dir"
                                  ,"COMMAND_CURE_START_REP"             => "istatus"
                                  ,"COMMAND_CURE_STOP_REP"              => "istatus"
                                  ,"COMMAND_CURE_RESULT_REP"            => "icurecnt/a*curelist"

                                  ,"COMMAND_SUPDATE_START_REP"          => "istatus"
                                  ,"COMMAND_SUPDATE_STOP_REP"           => "istatus"
                                  ,"COMMAND_SUPDATE_STATUS_REP"         => "istatus/ierrcode/ifiledownstatus"
                                  ,"COMMAND_SUPDATE_FILE_REP"           => "itotal/itotalcopy/ifilecnt/ilastindex/a*filelist"
                                  ,"COMMAND_SUPDATE_AUTOCOPY_REP"       => "istatus"
                                  ,"COMMAND_APC_SCAN_START_REP"         => "istatus"
                                  ,"COMMAND_APC_RESERVE_INSERT_REP"     => "istatus"

                                  ,"COMMAND_MANAGER_AUTO_START_REP"            => "istatus"
                                  ,"COMMAND_MANAGER_CHANGE_SERVER_INFO_REP"    => "istatus"
                                  ,"COMMAND_EVENT_LOG_REP"                     => "istatus"
                                  ,"COMMAND_QUARANTINE_RESTORE_REP"            => "istatus/a*restore_info"

                                  ,"COMMAND_CONFIG_UPDATE_PROXY_SET_REP"=> "istatus"
                                  ,"COMMAND_CONFIG_SET_EULA_REP"        =>"iresult"

                                  );
    function __construct() { $this->connect(); }
    function __destruct() { $this->close(); }

    public function sendCmd($cmd, &$body)
    {
        try{
            $bodyLength = strlen($body);
            $reqHeader = $this->reqHeader($cmd, $bodyLength);
            if ($reqHeader != null){
                $this->send($reqHeader);
                if ($bodyLength > 0) $this->send($body);
                return true;
            }
        }
        catch(Exception $e){
            $filename = $_SERVER["DOCUMENT_ROOT"].basename(__FILE__).".error.log";
            clearstatcache();
            $fileOpenOption = "a+";
            if (filesize($filename)>5000) $fileOpenOption = "w+";
            if ($handle = fopen($filename, $fileOpenOption)) {
                $somecontent = "[".date("Y-m-d H:i:s")."] 명령 : ".$cmd." ( ". $e->getMessage() . " )\n";
                fwrite($handle, $somecontent);
                fclose($handle);
            }
        }
        return false;
    }
    public function reqHeader($cmd, $bodyLength)
    {
        $rtn = null;
        $packetCmd = "COMMAND_" . strtoupper($cmd) . "_REQ";
        PHPLOG(g_LOG_DEBUG, 0, "filescan_protocol.inc : [reqHeader] Header - packetCmd(".$packetCmd.") bodyLength(".$bodyLength.")");
        if (isset($this->packet_type[$packetCmd])){
            PHPLOG(g_LOG_DEBUG, 0, "filescan_protocol.inc : [reqHeader] Header - command(".$this->packet_type[$packetCmd].") size(".$bodyLength.")" );
            $rtn = pack("aII", $this->packet_head, $this->packet_type[$packetCmd], $bodyLength );
        }
        return $rtn;
    }
    public function readCmd($cmd)
    {
        $rtn = null;
        $headValue = $this->resHeader($cmd);
        if ($headValue != null && $headValue["head"] == "#")
        {
            $rtn = $this->resBody($cmd, $headValue["size"]);
        }
        return $rtn;
    }
    public function resHeader($cmd)
    {
        $packetCmd = "COMMAND_" . strtoupper($cmd) . "_REP";
        PHPLOG(g_LOG_DEBUG, 0, "filescan_protocol.inc : [resHeader] Header - packetCmd(".$packetCmd.")");
        if (isset($this->packet_type[$packetCmd])){
            $resHeader = $this->read(9);
            if(strlen($resHeader) <= 0) {
                PHPLOG(g_LOG_ERROR, 0, "filescan_protocol.inc : [resHeader] Header is empty.");
                return null;
            }
            $unpackData = unpack("ahead/icmd/isize", $resHeader);
            PHPLOG(g_LOG_DEBUG, 0, "filescan_protocol.inc : [resHeader] Header - command(".$unpackData["cmd"].") size(".$unpackData["size"].")" );
            
            return $unpackData;
        }
        else{
            return null;
        }
    }
    public function resBody($cmd, $nByte)
    {
        $packetCmd = "COMMAND_" . strtoupper($cmd) . "_REP";
        if (isset($this->packet_type[$packetCmd])){
            if ($nByte > 0){
                $resHeader = $this->read($nByte);
                return unpack($this->res_body_type[$packetCmd], $resHeader);
            }
            else{
                return "";
            }
        }
        else{
            return null;
        }
    }
}
$GLOBALS["g_fss"] = new protocalCls();
?>
