<?php
class socketCls
{
    protected $socket = null;

    private   $soc_host = "unix:///tmp/.v3dld.sock";
    private   $soc_port = 0;
    private   $soc_errno = 0;
    private   $soc_errstr = "";
    private   $read_max_byte = 4096;
    private   $isError = false;

    function __construct() {
        $this->isError = false;
    }

    function __destruct() {
        $this->close();
    }

    public function setHost($s){$this->soc_host = $s;}
    public function setPort ($s){$this->soc_port = $s;}

    public function connect()
    {
        $this->close();
        if (!$this->socket = @fsockopen($this->soc_host, $this->soc_port, $this->soc_errno, $this->soc_errstr)){
            $this->isError = true;
        }
    }
    public function close()
    {
        if ($this->socket) fclose($this->socket);
    }
    public function setReadByte($b)
    {
        $this->read_max_byte = $b;
    }

    public function getErrMsg(){ return $this->soc_errstr." (".$this->soc_errno.")"; }
    public function getError(){ return $this->isError; }

    public function send($s)
    {
        if ($this->socket){
            fwrite($this->socket, $s);
            return true;
        }
        else 
        {
            PHPLOG(g_LOG_ERROR, 0, "filescan_socket.inc : [send] Invalid socket(".$this->socket.")");
            return false;
        }
    }

    public function read($readByte)
    {
        $buffer = "";
        if ($this->socket){
            $buffer_tmp = "";
            $bufferReadByte = 0;
            do{
                $currentReadByte = (($readByte - $bufferReadByte) > $this->read_max_byte)?$this->read_max_byte:($readByte - $bufferReadByte);
                $buffer .= fread($this->socket, $currentReadByte);
                $bufferReadByte += $currentReadByte;
            }while($readByte > $bufferReadByte);
        }
        else
        {
            PHPLOG(g_LOG_ERROR, 0, "filescan_socket.inc : [read] Invalid socket(".$this->socket.")");
        }
        
        return $buffer;
    }
}
?>
