<?php
/******************************************************************************
 *
 *  (C) 2018 AhnLab, Inc. All rights reserved.
 *  Any part of this source code can not be copied with any method without
 *  prior written permission from the author or authorized person.
 *
 ******************************************************************************/
require_once $_SERVER["DOCUMENT_ROOT"]."base_var.inc.php";
inc_func(g_inc_type_var, "msg_abou");
inc_func(g_inc_type_var, "msg_com");

try {
    $g_db->open();

    $query = "pragma table_info(server_info);";
    $rsTableType = $g_db->queryAll($query);
    if ($g_db->error_code() != SQLITE_OK) {
        throw new Exception();
    }

    $rsTableTypeLen = count($rsTableType);
    $isProductType = false;

    // product_type 컬럼이 테이블에 존재하는지 찾기
    for($i = 0; $i < $rsTableTypeLen; $i++) {
        if($rsTableType[$i]['name'] == 'product_type') {
            $isProductType = true;
            break;
        }
    }
    $query = " select id, email, product_name, product_version, date(install_date) as ins_date "
            ."      , install_path, ifnull(language, '".$GLOBALS["g_msg_type"]."') as lang, server_ip, engine_version "
            ."      , homepage_url as home, suppoort_email as support "
            .       ($isProductType ? ", product_type " : "")
            ." from server_info where no = 1; ";
    $rs = $g_db->getrow($query);
    if ($g_db->error_code() != SQLITE_OK) {
        throw new Exception();
    }
} catch (Exception $e) {
    /* TODO: */
}

$g_db->close();

// 기본 값: 32bit
if($rs['product_type'] == '64') {
    $product_type = $g_msg_text["abou"]["txt12_02"];
} else if ($rs['product_type'] == '32') {
    $product_type = $g_msg_text["abou"]["txt12_01"];    
} else {
    $product_type = "";
}

$pagetitle = getTitle();
$localeLower = explode('_', $g_msg_type);
$localeUrl = $localeLower[0]."_".strtoupper($localeLower[1]);
if (getProduct() == "v3dl")
{
    $pageci = "pop_tit_linux_desktop.gif";
    $ossHelpUrl = "../license/license.txt";
    $copyright = $g_msg_text["com"]["copyright_desktop"];
}
else if(getProduct() == "v3ll")
{
    $pageci = "pop_tit_linux_v3lite.gif";
    $ossHelpUrl = "../license/license_v3ll.txt";
    $copyright = $g_msg_text["com"]["copyright_desktop_openos"];
}

echo page_start($g_msg_text["abou"]["ttl01"]);
echo <<<__HTML_TEXT__
<script language="javascript">
<!--//
function openOssHelpUrl() {
	window.open("{$ossHelpUrl}", '_blank');

}

function pageOnLoad(){
    $("okBtn").focus();
}
//-->
</script>
<body onload="javascript:pageOnLoad()">
<div class="wrapPop" style="margin-right:2px;">
<!-- header -->
    <div class="popHeader2">
        <h1><img src="{$IMG_ROOT}{$pageci}" alt="{$pagetitle}"></h1>
    </div>
<!-- //header -->
    <div class="popCont">
        <span class="rtop"><span class="r1"></span></span>
        <div class="popContBox">
<!-- Contents Area -->

            <div class="prodInfo">
                <ul class="prodInfoList">
                <li>{$g_msg_text["abou"]["txt02"]}: {$rs["product_version"]}</li>
                <li>{$g_msg_text["abou"]["txt08"]}: {$rs["engine_version"]}</li>
                <li>{$g_msg_text["abou"]["txt12"]}: {$product_type}</li>
                <li><div class="prodInfoBar"></div></li>
                <li>{$g_msg_text["abou"]["txt03"]}: {$rs["ins_date"]}</li>
                <li>{$g_msg_text["abou"]["txt04"]}: {$rs["install_path"]}</li>
                <li>{$g_msg_text["abou"]["txt05"]}: {$g_msg_text["abou"]["txt05_".$GLOBALS["g_msg_type"]]}</li>
                <li>{$g_msg_text["abou"]["txt11"]}: <a href="#" onclick="javascript:openOssHelpUrl();">{$g_msg_text["abou"]["txt11_lnk01"]}</a></li>
                <li><p class="copyright">{$copyright}</p></li>
                </ul>
            </div>

<!-- //Contents Area -->
        </div>
    </div>
<!-- Footer -->
    <div class="popFooter"><span class="rbottom"><span class="r1"></span></span></div>
<!-- //Footer -->
    <div class="fr" style="padding:6px 10px 0px 0px;">
        <div class="btnSet">
            <a href="#" id="okBtn" class="button smallBlue" onclick="javascript:self.close()"><span class="w72" style="background-color:#303f62;">{$g_msg_text["com"]["btn_ok"]}</span></a>
        </div>
    </div>
</div>
</body>
__HTML_TEXT__;
echo page_end();
?>
