<?php
/******************************************************************************
 *
 *  (C) 2018 AhnLab, Inc. All rights reserved.
 *  Any part of this source code can not be copied with any method without
 *  prior written permission from the author or authorized person.
 *
 ******************************************************************************/
$PAGE_LOGIN = 2;
require_once $_SERVER["DOCUMENT_ROOT"]."base_var.inc.php";

function getData()
{
    if (intval(nvl($_POST["resv_target"])) == 1) $argu["target"] = 1;
    else $argu["target"] = 2;
    if (intval(nvl($_POST["resv_ext_on"])) == 1) $argu["extension_on"] = 1;
    else $argu["extension_on"] = 0;
    $argu["extension"] = nvl($_POST["resv_ext"]);
    $tmp = intval(nvl($_POST["resv_cure"]));
    if ($tmp >= 1 && $tmp <= 3) $argu["cure_option"] = $tmp;
    else $argu["cure_option"] = 3;
    if (intval(nvl($_POST["resv_comp"])) == 1) $argu["compress_option"] = 1;
    else $argu["compress_option"] = 2;
    if (intval(nvl($_POST["resv_auto"])) == 1) $argu["auto_cure"] = 1;
    else $argu["auto_cure"] = 0;
    if (intval(nvl($_POST["resv_quar"])) == 1) $argu["move_quarantine"] = 1;
    else $argu["move_quarantine"] = 0;

    $argu["name"] = nvl($_POST["resv_name"]);
    $tmp = intval(nvl($_POST["resv_cycle"]));
    if ($tmp >= 1 && $tmp <= 4) $argu["cycle"] = $tmp;
    else $argu["cycle"] = 0;

    $tmp = intval(nvl($_POST["resv_hour"]));
    if ($tmp >= 0 && $tmp <= 23) $argu["hour"] = $tmp;
    else $argu["hour"] = 0;

    $tmp = intval(nvl($_POST["resv_min"]));
    if ($tmp >= 0 && $tmp <= 59) $argu["min"] = $tmp;
    else $argu["min"] = 0;

    $tmp = intval(nvl($_POST["resv_day"]));
    if ($tmp >= 0 && $tmp <= 31) $argu["day"] = $tmp;
    else $argu["day"] = 0;

    $tmp = intval(nvl($_POST["resv_week"]));
    if ($tmp >= 0 && $tmp <= 6) $argu["week"] = $tmp;
    else $argu["week"] = 0;

    $argu["compress"] = intval(nvl($_POST["resv_compress"]));
    
    $argu["cpu_usage"] = intval(nvl($_POST["resv_cpu_usage"]));

    /* VNIX-2624 검사 수행 시간 설정 */
    $argu["period_use"] = intval(nvl($_POST["resv_period_use"]));
    $argu["period"] = intval(nvl($_POST["resv_period_hour"])) * 60 + intval(nvl($_POST["resv_period_min"]));

    $argu["resume_use"] = intval(nvl($_POST["resv_resume_use"]));

    PHPLOG(g_LOG_NORMAL, 0, "Setting Query : ".$argu["period_use"]. ",".$augu["period"]); 

    /* VNIX-2623 검사 파일 사이즈 설정 추가 */
    $argu["filesize_use"] = intval(nvl($_POST["resv_filesize_use"]));
 	$argu["filesize"] = intval(nvl($_POST["resv_filesize"]));

    $currentTimeValue = (intval(date("H")) * 60 * 60) + (intval(date("i")) * 60);
    $inputTimeValue = (intval($argu["hour"]) * 60 * 60) + (intval($argu["min"]) * 60);
    $nextCureDay = ($currentTimeValue > $inputTimeValue)?1:0;

    switch($argu["cycle"]){
    case 1:
        $argu["view_time"] = date("Y-m-d H:i:s", mktime($argu["hour"],$argu["min"], 0, intval(date("n")), intval(date("j")), intval(date("Y"))));
        $argu["check_time"] = date("H:i", mktime ($argu["hour"],$argu["min"], 0, intval(date("n")), intval(date("j")), intval(date("Y"))));
        $argu["cure_time"] = date("Y-m-d H:i:s", mktime($argu["hour"],$argu["min"], 0, intval(date("n")), intval(date("j")) + $nextCureDay, intval(date("Y"))));
        break;
    case 2:
        $argu["view_time"] = date("Y-m-d H:i:s", mktime($argu["hour"],$argu["min"], 0, intval(date("n")), intval(date("j")) + ($argu["week"] - intval(date("w"))), intval(date("Y"))));
        $argu["check_time"] = date("w H:i", mktime ($argu["hour"],$argu["min"], 0, intval(date("n")), intval(date("j")) + ($argu["week"] - intval(date("w"))), intval(date("Y"))));
        $argu["cure_time"] = date("Y-m-d H:i:s", mktime($argu["hour"],$argu["min"], 0, intval(date("n")), intval(date("j")) + ((7 * $nextCureDay) - intval(date("w")) + $argu["week"]), intval(date("Y"))));
        break;
    case 3:
        $argu["view_time"] = date("Y-m-".str_pad($argu["day"], 2, "0", STR_PAD_LEFT)." H:i:s", mktime($argu["hour"],$argu["min"], 0, intval(date("n")), 1, intval(date("Y"))));
        $argu["check_time"] = date(str_pad($argu["day"], 2, "0", STR_PAD_LEFT)." H:i", mktime ($argu["hour"],$argu["min"], 0, intval(date("n")), 1, intval(date("Y"))));
        $argu["cure_time"] = date("Y-m-".str_pad($argu["day"], 2, "0", STR_PAD_LEFT)." H:i:s", mktime($argu["hour"],$argu["min"], 0, intval(date("n")) + $nextCureDay, 1, intval(date("Y"))));
        break;
    case 4:
        $tmp = split("-", nvl($_POST["resv_date"]), 3 );
        if (sizeof($tmp) != 3) throw new Exception("VIEW_DATE_ERROR");
        $tmp[0] = intval($tmp[0]);
        $tmp[1] = intval($tmp[1]);
        $tmp[2] = intval($tmp[2]);
        if ($tmp[0] < intval(date("Y"))) throw new Exception("VIEW_DATE_ERROR");
        if ($tmp[1] > 12) throw new Exception("VIEW_DATE_ERROR");
        if ($tmp[2] > intval(date("t", mktime(0,0,0,$tmp[1],1,$tmp[0])))) throw new Exception("VIEW_DATE_ERROR");

        if (strtotime($tmp[0]."-".$tmp[1]."-".$tmp[2]." ".$argu["hour"].":".$argu["min"].":00") < mktime ()) throw new Exception("VIEW_DATE_ERROR");
        $argu["view_time"] = date("Y-m-d H:i:s", mktime ($argu["hour"],$argu["min"], 0, $tmp[1], $tmp[2], $tmp[0]));
        $argu["check_time"] = date("Y-m-d H:i", mktime ($argu["hour"],$argu["min"], 0, $tmp[1], $tmp[2], $tmp[0]));
        $argu["cure_time"] = date("Y-m-d H:i:s", mktime ($argu["hour"],$argu["min"], 0, $tmp[1], $tmp[2], $tmp[0]));
        break;
    }
    return $argu;
}

$cmd = nvl($_POST["cmd"]);


try {
    $g_db->open();
} catch (Exception $e) {
    /* TODO: */    
}

switch(strtoupper($cmd))
{
case "RESV_ADD":
    try {
        $query = " select count(*) as reserveCnt "
                ." from   temp_reserve "
                ." where  ifnull(type, 1) = 1 "
                ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."' "
                ." and    sess_status >= 0 ;";
        $rs = $g_db->getrow($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        if ($rs["reserveCnt"] > 9) throw new Exception("RESERVE_MAX_OVER");

        $argu = getData();

        $query = " select count(*) as reserveCnt "
                ." from   temp_reserve "
                ." where  upper(name) = '".strDb(strtoupper($argu["name"]))."' "
                ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."' "
                ." and    sess_status >= 0 ;";

        $rs = $g_db->getrow($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        if ($rs["reserveCnt"] > 0) throw new Exception("SAME_NAME");

        $query = " select count(*) as reserveCnt from temp_reserve "
                ." where  1 =( case cycle "
                ."                  when 1 then case when strftime('%H:%M', view_time) = '".strDb($argu["check_time"])."' then 1 else 0 end "
                ."                  when 2 then case when strftime('%w %H:%M', view_time) = '".strDb($argu["check_time"])."' then 1 else 0 end "
                ."                  when 3 then case when strftime('%d %H:%M', view_time) = '".strDb($argu["check_time"])."' then 1 else 0 end "
                ."                  when 4 then case when strftime('%Y-%m-%d %H:%M', view_time) = '".strDb($argu["check_time"])."' then 1 else 0 end "
                ."                         else 0 end ) "
                ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."' "
                ." and    sess_status >= 0 ;";
        $rs = $g_db->getrow($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        if ($rs["reserveCnt"] > 0) throw new Exception("SAME_RULE");

        $g_db->setTrans();
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        $query = " insert into temp_scan_option (target, extension_on, extension, cure_option, compress_option, auto_cure, "
                ." move_quarantine, compress_use, session, sess_status, scan_option_no, cpu_usage, "
                ." period_use, period, resume_use,"
                ." filesize_use, filesize) "
                ." values ('".strDb($argu["target"])."','".strDb($argu["extension_on"])."','".strDb($argu["extension"])."','".strDb($argu["cure_option"])."','".strDb($argu["compress_option"])."','".strDb($argu["auto_cure"])."'"
                .",'".strDb($argu["move_quarantine"])."', '".strDb($argu["compress"])."', '".strDb($_SESSION["LOGIN_SESSION"])."', 2, -1, '".strDb($argu["cpu_usage"])."'"
                .",'".strDb($argu["period_use"])."','".strDb($argu["period"])."','".strDb($argu["resume_use"])."'"
                .",'".strDb($argu["filesize_use"])."','".strDb($argu["filesize"])."');";
        
        PHPLOG(g_LOG_NORMAL, 0, "Setting Query : ".$query);
        $rs = $g_db->exec($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        if ($rs < 1) throw new Exception("ERROR");

        $query = " insert into temp_reserve (scan_option_no, name, cycle, view_time, cure_time, status, type, session, sess_status, reserve_no)"
                ." values ((select max(a.no) from temp_scan_option a), '".strDb($argu["name"])."', ".strDb($argu["cycle"]).", '".strDb($argu["view_time"])."', '".strDb($argu["cure_time"])."', 0, 1, '".strDb($_SESSION["LOGIN_SESSION"])."', 2, -1)";

        $rs = $g_db->exec($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        if ($rs < 1) throw new Exception("ERROR");

        $query = " select max(no) maxreserve from temp_reserve ;";
        $rs = $g_db->getrow($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        $argu["reserve_no"] = $rs["maxreserve"];

        $tmp = 0;
        $resv_dirs = nvl($_POST["resv_dirs"]);
        if (strpos($resv_dirs, "|") === false) $arrDirs[0] = $resv_dirs;
        else $arrDirs = split("\\|", $resv_dirs);
        foreach($arrDirs as $value){
            if (trim($value) != "") {
                $argu["path"] = strDb($value);
                $query = " insert into temp_dir (reserve_no, path, session, sess_status, dir_no)"
                        ." values ('".strDb($argu["reserve_no"])."', '".strDb($argu["path"])."', '".strDb($_SESSION["LOGIN_SESSION"])."', 2, -1)";
                $rs = $g_db->exec($query);
                if ($g_db->error_code() != SQLITE_OK) {
                    throw new Exception("ERROR");
                }

                if ($rs > 0) $tmp++;
            }
        }
        if ($tmp < 1) throw new Exception("ERROR");

        $g_db->commit();
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        echo "OK";
    } catch(Exception $e) {
        echo $e->getMessage();
        $g_db->rollback();
    }
    break;
case "RESV_MOD":
    try {
        $argu = getData();
        $argu["resv_no"] = intval(nvl($_POST["resv_no"]));

        $query = " select count(*) as reserveCnt "
                ." from   temp_reserve "
                ." where  upper(name) = '".strDb(strtoupper($argu["name"]))."' "
                ." and    no != '".strDb($argu["resv_no"])."' "
                ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."' "
                ." and    sess_status >= 0 ;";
        $rs = $g_db->getrow($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        if ($rs["reserveCnt"] > 0) throw new Exception("SAME_NAME");

        $query = " select count(*) as reserveCnt from temp_reserve "
                ." where  no != '".strDb($argu["resv_no"])."' "
                ." and    1=( case cycle "
                ."                when 1 then case when strftime('%H:%M', view_time) = '".strDb($argu["check_time"])."' then 1 else 0 end "
                ."                when 2 then case when strftime('%w %H:%M', view_time) = '".strDb($argu["check_time"])."' then 1 else 0 end "
                ."                when 3 then case when strftime('%d %H:%M', view_time) = '".strDb($argu["check_time"])."' then 1 else 0 end "
                ."                when 4 then case when strftime('%Y-%m-%d %H:%M', view_time) = '".strDb($argu["check_time"])."' then 1 else 0 end "
                ."                       else 0 end ) "
                ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."' "
                ." and    sess_status >= 0 ;";
        $rs = $g_db->getrow($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        if ($rs["reserveCnt"] > 0) throw new Exception("SAME_RULE");

        $query = " select count(*) as reserveCnt, scan_option_no "
                ." from   temp_reserve "
                ." where  no = '".strDb($argu["resv_no"])."' "
                ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."' "
                ." and    sess_status >= 0 ;";
        $rs = $g_db->getrow($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        if ($rs["reserveCnt"] < 1) throw new Exception("RESERVE_NOT_FOUND");

        $argu["scan_option_no"] = $rs["scan_option_no"];
        $g_db->setTrans();
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        $query = " update temp_scan_option set "
                ."        target = '".strDb($argu["target"])."' "
                ."      , extension_on = '".strDb($argu["extension_on"])."' "
                ."      , extension = '".strDb($argu["extension"])."' "
                ."      , cure_option = '".strDb($argu["cure_option"])."' "
                ."      , compress_option = '".strDb($argu["compress_option"])."' "
                ."      , auto_cure = '".strDb($argu["auto_cure"])."' "
                ."      , move_quarantine = '".strDb($argu["move_quarantine"])."' "
                ."      , compress_use = '".strDb($argu["compress"])."' "
                ."      , sess_status = (case sess_status when 2 then 2 when -1 then -1 else 1 end) "
                ."      , cpu_usage = '".strDb($argu["cpu_usage"])."' "
                ."	    , period_use = '".strDb($argu["period_use"])."' "
                ."	    , period = '".strDb($argu["period"])."' "
                ."	    , resume_use = '".strDb($argu["resume_use"])."' "
                ."	    , filesize_use = '".strDb($argu["filesize_use"])."' "
                ."	    , filesize = ".strDb($argu["filesize"])
                ." where  no = '".strDb($argu["scan_option_no"])."' "
                ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."' ;";
        $rs = $g_db->exec($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        if ($rs < 1) throw new Exception("ERROR");

        $query = " update temp_reserve set "
                ."        name = '".strDb($argu["name"])."' "
                ."      , cycle = '".strDb($argu["cycle"])."' "
                ."      , view_time = '".strDb($argu["view_time"])."' "
                ."      , cure_time = '".strDb($argu["cure_time"])."' "
                ."      , sess_status = (case sess_status when 2 then 2 when -1 then -1 else 1 end) "
                ." where  no = '".strDb($argu["resv_no"])."' "
                ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."' ;";
        $rs = $g_db->exec($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        if ($rs < 1) throw new Exception("ERROR");

        $query = " delete from temp_dir "
                ." where  reserve_no = '".$argu["resv_no"]."' "
                ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."' ;";
        $rs = $g_db->getrow($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        $tmp = 0;
        $resv_dirs = nvl($_POST["resv_dirs"]);
        if (strpos($resv_dirs, "|") === false) $arrDirs[0] = $resv_dirs;
        else $arrDirs = split("\\|", $resv_dirs);

        foreach($arrDirs as $value){
            if (trim($value) != "") {
                $argu["path"] = strDb($value);
                $query = " insert into temp_dir (reserve_no, path, session, sess_status, dir_no)"
                        ." values ('".strDb($argu["resv_no"])."', '".strDb($argu["path"])."', '".strDb($_SESSION["LOGIN_SESSION"])."', 2, -1)";
                $rs = $g_db->exec($query);
                if ($g_db->error_code() != SQLITE_OK) {
                    throw new Exception("ERROR");
                }

                if ($rs > 0) $tmp++;
            }
        }
        if ($tmp < 1) throw new Exception("ERROR");

        $g_db->commit();
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        echo "OK";
    } catch(Exception $e) {
        echo $e->getMessage();
        $g_db->rollback();
    }

    break;
case "RESV_DEL":
    try {
        $tmp = nvl($_POST["data"]);
        if (strpos($tmp, "|") === false) $delList[0] = $tmp;
        else $delList = split("\\|", $tmp);

        $g_db->setTrans();
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        $tmp = 0;
        foreach($delList as $value){
            $argu["resv_no"] = intval($value);
            $query = " select status from reserve "
                    ." where no = (select reserve_no from temp_reserve "
                    ."             where  no = '".strDb($argu["resv_no"])."' "
                    ."             and    session = '".strDb($_SESSION["LOGIN_SESSION"])."'); ";
            $rs = $g_db->getrow($query);
            if ($g_db->error_code() != SQLITE_OK) {
                throw new Exception("ERROR");
            }

            if ($rs["status"] == 1) throw new Exception("RUN_SCANNING");
            $query = " select count(*) as reserveCnt, scan_option_no, sess_status "
                    ." from   temp_reserve "
                    ." where  ifnull(type, 1) = 1 "
                    ." and    no = '".strDb($argu["resv_no"])."' "
                    ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."' "
                    ." and    sess_status >= 0 "
                    ." group  by scan_option_no, sess_status ;";
            $rs = $g_db->getrow($query);
            if ($g_db->error_code() != SQLITE_OK) {
                throw new Exception("ERROR");
            }

            if ($rs["reserveCnt"] == 1) {
                $argu["scan_option_no"] = $rs["scan_option_no"];

                $query=" delete from temp_dir "
                      ." where  reserve_no = '".strDb($argu["resv_no"])."' "
                      ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."'; " ;
                $changes = $g_db->exec($query);
                if ($g_db->error_code() != SQLITE_OK) {
                    throw new Exception("ERROR");
                }

                if ($changes < 1) throw new Exception("ERROR");

                if ($rs["sess_status"] == 2){
                    $query=" delete from temp_scan_option "
                          ." where  no = '".strDb($argu["scan_option_no"])."' "
                          ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."'; ";
                    $changes = $g_db->exec($query);
                    if ($g_db->error_code() != SQLITE_OK) {
                        throw new Exception("ERROR");
                    }

                    if ($changes < 1) throw new Exception("ERROR");

                    $query=" delete from temp_reserve "
                          ." where  no = '".strDb($argu["resv_no"])."' "
                          ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."'; ";
                    $changes = $g_db->exec($query);
                    if ($g_db->error_code() != SQLITE_OK) {
                        throw new Exception("ERROR");
                    }

                    if ($changes < 1) throw new Exception("ERROR");
                } else {
                    $query=" update temp_scan_option set "
                          ."        sess_status = -1 "
                          ." where  no = '".strDb($argu["scan_option_no"])."' "
                          ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."'; ";
                    $changes = $g_db->exec($query);
                    if ($g_db->error_code() != SQLITE_OK) {
                        throw new Exception("ERROR");
                    }

                    if ($changes < 1) throw new Exception("ERROR");

                    $query=" update temp_reserve set "
                          ."        sess_status = -1 "
                          ." where  no = '".strDb($argu["resv_no"])."' "
                          ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."'; ";
                    $changes = $g_db->exec($query);
                    if ($g_db->error_code() != SQLITE_OK) {
                        throw new Exception("ERROR");
                    }

                    if ($changes < 1) throw new Exception("ERROR");
                }

                $tmp++;
            }
        }
        
        $g_db->commit();
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        if ($tmp > 0) {
            echo "OK";
        } else {
            echo "RESERVE_NOT_FOUND";
        }
    } catch(Exception $e) {
        echo $e->getMessage();
        $g_db->rollback();
    }

    break;
}
$g_db->close();
?>
