<?php
/******************************************************************************
 *
 *  (C) 2018 AhnLab, Inc. All rights reserved.
 *  Any part of this source code can not be copied with any method without
 *  prior written permission from the author or authorized person.
 *
 ******************************************************************************/
$PAGE_LOGIN = 2;
require_once $_SERVER["DOCUMENT_ROOT"]."base_var.inc.php";

$cmd = nvl($_POST["cmd"]);
$ulst_no = intval(nvl($_POST["ulst_no"]));
$ulst_name = nvl($_POST["ulst_name"]);
$ulst_dir = nvl($_POST["ulst_dirs"]);

try {
    $g_db->open();

    $g_db->setTrans();
    if ($g_db->error_code() != SQLITE_OK) {
        throw new Exception("ERROR");
    }

    switch(strtoupper($cmd))
    {
    case "ULST_ADD":
        if ($ulst_name == "") throw new Exception();
        if ($ulst_dir == "") throw new Exception();

        $query=" select count(*) as listCnt
                 from   temp_user_list a
                 where  session = '".strDb($_SESSION["LOGIN_SESSION"])."'
                 and    sess_status >= 0 ;";
        $rs = $g_db->getrow($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        if ($rs["listCnt"] > 9) throw new Exception("ULST_MAX_OVER");

        $query=" select count(*) as nameCnt
                 from   temp_user_list a
                 where  upper(a.name) = '".strDb(strtoupper($ulst_name))."'
                 and    session = '".strDb($_SESSION["LOGIN_SESSION"])."'
                 and    sess_status >= 0 ;";
        $rs = $g_db->getrow($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        if ($rs["nameCnt"] > 0) throw new Exception("SAME_NAME");

        $query = " insert into temp_user_list (name, session, sess_status, user_list_no)
                   values ('".strDb($ulst_name)."', '".strDb($_SESSION["LOGIN_SESSION"])."', 2, -1) ";
        $g_db->exec($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        $query = " select max(no) as maxno
                   from   temp_user_list
                   where  session = '".strDb($_SESSION["LOGIN_SESSION"])."'
                   and    sess_status >= 0 ;";
        $rs = $g_db->getrow($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        $ulst_no = $rs["maxno"];

        $tmp = 0;
        if (strpos($ulst_dir, "|") === false) $arrDirs[0] = $ulst_dir;
        else $arrDirs = split("\\|", $ulst_dir);
        foreach($arrDirs as $value){
            if (trim($value) != "") {
                $query = " insert into temp_dir (user_list_no, path, session, sess_status, dir_no)
                           values (".$ulst_no.", '".strDb($value)."', '".strDb($_SESSION["LOGIN_SESSION"])."', 2, -1);";
                $rs = $g_db->exec($query);
                if ($g_db->error_code() != SQLITE_OK) {
                    throw new Exception("ERROR");
                }

                if ($rs > 0) $tmp++;
            }
        }
        if ($tmp < 1) throw new Exception("ERROR");
        echo "OK";
        break;
    case "ULST_MOD":
        if ($ulst_name == "") throw new Exception();
        if ($ulst_dir == "") throw new Exception();

        $query=" select count(*) as nameCnt
                 from   temp_user_list a
                 where  upper(a.name) = '".strDb(strtoupper($ulst_name))."'
                 and    no != ".$ulst_no."
                 and    session = '".strDb($_SESSION["LOGIN_SESSION"])."'
                 and    sess_status >= 0 ;";
        $rs = $g_db->getrow($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        if ($rs["nameCnt"] > 0) throw new Exception("SAME_NAME");

        $query = " update temp_user_list set
                          name = '".strDb($ulst_name)."'
                         ,sess_status = (case sess_status when 2 then 2 else 1 end)
                   where  no = ".$ulst_no."
                   and    session = '".strDb($_SESSION["LOGIN_SESSION"])."'
                   and    sess_status >= 0 ;";
        $rs = $g_db->exec($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        if ($rs < 1) throw new Exception("ERROR");

        $query = " delete from temp_dir
                   where  user_list_no = '".strDb($ulst_no)."'
                   and    session = '".strDb($_SESSION["LOGIN_SESSION"])."'
                   and    sess_status >= 0 ;";
        $g_db->exec($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }

        $tmp = 0;
        if (strpos($ulst_dir, "|") === false) $arrDirs[0] = $ulst_dir;
        else $arrDirs = split("\\|", $ulst_dir);
        foreach($arrDirs as $value){
            if (trim($value) != "") {
                $query = " insert into temp_dir (user_list_no, path, session, sess_status, dir_no)"
                        ." values (".$ulst_no.", '".strDb($value)."', '".strDb($_SESSION["LOGIN_SESSION"])."', 2, -1)";
                $rs = $g_db->exec($query);
                if ($g_db->error_code() != SQLITE_OK) {
                    throw new Exception("ERROR");
                }

                if ($rs > 0) $tmp++;
            }
        }
        if ($tmp < 1) throw new Exception("ERROR");
        echo "OK";
        break;
    case "ULST_DEL":
        $tmp = nvl($_POST["data"]);
        if (strpos($tmp, "|") === false) $delList[0] = $tmp;
        else $delList = split("\\|", $tmp);

        $tmp = 0;
        foreach($delList as $value){
            $ulst_no = intval($value);

            $query = " delete from temp_dir "
                    ." where  user_list_no = '".strDb($ulst_no)."' "
                    ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."' ;";
            $g_db->exec($query);
            if ($g_db->error_code() != SQLITE_OK) {
                throw new Exception("ERROR");
            }

            $query = " select sess_status from temp_user_list "
                    ." where  no = '".strDb($ulst_no)."' "
                    ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."' ;";
            $rs = $g_db->getrow($query);
            if ($g_db->error_code() != SQLITE_OK) {
                throw new Exception("ERROR");
            }

            if ($rs["sess_status"] == 2){
                $query = " delete from temp_user_list "
                        ." where  no = '".strDb($ulst_no)."' "
                        ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."' ;";
            } else {
                $query = " update temp_user_list set "
                        ."        sess_status = -1 "
                        ." where no = '".strDb($ulst_no)."' "
                        ." and    session = '".strDb($_SESSION["LOGIN_SESSION"])."' ;";
            }
            $g_db->exec($query);
            if ($g_db->error_code() != SQLITE_OK) {
                throw new Exception("ERROR");
            }

            $tmp++;
        }
        if ($tmp > 0) echo "OK";
        else echo "ULST_NOT_FOUND";
        break;
    case "ULST_DIRS":
        $ulst_no = intval(nvl($_POST["list_no"], "-1"));

        $query = " select group_concat(b.path, '|') as dirs from dir b where b.user_list_no = ".$ulst_no."; ";
        $rs = $g_db->getrow($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception("ERROR");
        }
        
        echo $rs["dirs"];
        break;
    }

    $g_db->commit();
    if ($g_db->error_code() != SQLITE_OK) {
        throw new Exception("ERROR");
    }
} catch(Exception $e) {
    echo $e->getMessage();
    $g_db->rollback();
}

$g_db->close();
?>
