<?php
/******************************************************************************
 *
 *  (C) 2018 AhnLab, Inc. All rights reserved.
 *  Any part of this source code can not be copied with any method without
 *  prior written permission from the author or authorized person.
 *
 ******************************************************************************/
$PAGE_LOGIN = 4;
require_once $_SERVER["DOCUMENT_ROOT"]."base_var.inc.php";
inc_func(g_inc_type_var, "msg_serv_alrt");
inc_func(g_inc_type_var, "msg_rebo");

$isError = "false";
$errorType = "NONE";
$isNewPort = "false";

try {
    $g_db->open();

    $result = 0;
    $newPort = intval($_COOKIE["changeport"]);

    $g_db->setTrans();
    if ($g_db->error_code() != SQLITE_OK) {
        throw new Exception();
    }

    $query = " select count(*), ifnull(port, 80) as server_port, server_ip from server_info where no = 1; ";
    $rs = $g_db->getrow($query);
    if ($g_db->error_code() != SQLITE_OK) {
        throw new Exception();
    }

    if($newPort && $rs["server_port"] <> $newPort) {
        PHPLOG(g_LOG_NORMAL, 0, "redirect_page : newPort(".$newPort.")");
        $isNewPort = "true";
        $query = " update server_info set "
               . "        port = '".strDb($newPort)."' "
               . " where  no = 1 ; ";
        $g_db->exec($query);
        if ($g_db->error_code() != SQLITE_OK) {
            throw new Exception();
        }
    } else {
        $newPort = 0;
    }

    if ($isNewPort == "true")
    {
        $cmdStr = "manager_change_server_info";
        $inData = pack("iia*", 0, $newPort, "");
        if ($g_fss->sendCmd($cmdStr,$inData))
        {
            $resData = $g_fss->readCmd($cmdStr);
            if ($resData["status"] == -1) {
                PHPLOG(g_LOG_DEBUG, 0, "redirect_page : Fail to restart V3. (port is already used)");
                throw new Exception("USED_PORT");
            }
            else if ($resData["status"] == -2) {
                PHPLOG(g_LOG_DEBUG, 0, "redirect_page : Fail to restart V3. (port is unavailable)");
                throw new Exception("RESTRICTED_PORT");
            }
        }
        else{
            PHPLOG(g_LOG_ERROR, 0, "redirect_page : Fail to readCmd");
            throw new Exception("");
        }
    }

    setWebSecurity($newWebSecurity);

    $g_db->commit();
    if ($g_db->error_code() != SQLITE_OK) {
        throw new Exception();
    }
    
    if($isNewPort == "true") makeEventLog("event_log_1000", "1005", array($rs["server_port"], $newPort));

} catch(Exception $e) {
    $g_db->rollback();
    $isError = "true";
    $errorType = $e->getMessage();
}

$g_db->close();

echo page_start();
echo <<<__HTML_TEXT__
<script language="javascript" type="text/javascript">
<!--//
var __Display_Time_Id__;
var displayTime = 10;
function timeDisplay(){
    var timeStr = "{$g_msg_text["serv_alrt"]["txt01"]}".replace("%1p", displayTime.toString(10));
    $("timeText").innerHTML = timeStr;
    displayTime--;
    if (displayTime < 0){
        if (__Display_Time_Id__) clearInterval(__Display_Time_Id__);
        __Display_Time_Id__ = null;

		this.returnValue = "SUCCESS";
		setReturnValue( this.returnValue);             //for Chrome
        window.parent.returnValue = this.returnValue;  //for IE,Firefox
        window.parent.self.close();
    }
}
function initPage()
{
    this.returnValue = "";
    if ({$isError}){
        this.returnValue = "{$errorType}";
        setReturnValue(this.returnValue);             //for Chrome
        window.parent.returnValue = this.returnValue;  //for IE,Firefox
        window.parent.self.close();
    }
    else{
        timeDisplay();
        __Display_Time_Id__ = setInterval(timeDisplay, 1000);
    }
}
//-->
</script>
<body class="wrapPopGray" onload="javascript:initPage();">
<table class="centerTbl" border=0 width="90%" height="100%" cellspacing="0" cellpadding="0">
    <tr>
        <td id="messageText" align="center" valign="middle">
__HTML_TEXT__;
        if($isNewPort == "true") echo $g_msg_text["serv_alrt"]["des03"];
        if($isError == "true") echo "<script> self.close(); </script>";
echo <<<__HTML_TEXT__
            <br><span id="timeText"></span>
        </td>
    </tr>
</table>
</body>
__HTML_TEXT__;
echo page_end();
?>