<?php
/******************************************************************************
 *
 *  (C) 2018 AhnLab, Inc. All rights reserved.
 *  Any part of this source code can not be copied with any method without
 *  prior written permission from the author or authorized person.
 *
 ******************************************************************************/
$NEED_FEATURE_CHECK = true;

require_once $_SERVER["DOCUMENT_ROOT"]."base_var.inc.php";
inc_func(g_inc_type_var, "msg_summ");
inc_func(g_inc_type_var, "msg_summ_stts01");
inc_func(g_inc_type_var, "msg_summ_stts02");
inc_func(g_inc_type_var, "msg_summ_stts03");
inc_func(g_inc_type_var, "msg_summ_stts04");
inc_func(g_inc_type_var, "msg_summ_stts05");
inc_func(g_inc_type_var, "msg_summ_vttl01");
inc_func(g_inc_type_var, "msg_summ_logm");
inc_func(g_inc_type_var, "msg_logm_virs");
inc_func(g_inc_type_var, "msg_scan");

$monthText = intval(date("m", mktime(0,0,0, date("m") -5, 1, date("Y"))));
$atMon = intval(date("m"));
$atMonthCnt = 0;
$totalCnt = 0;

$arrayAxisYText = array(1=>$g_msg_text["com"]["txt_mon1"]
                   ,$g_msg_text["com"]["txt_mon2"]
                   ,$g_msg_text["com"]["txt_mon3"]
                   ,$g_msg_text["com"]["txt_mon4"]
                   ,$g_msg_text["com"]["txt_mon5"]
                   ,$g_msg_text["com"]["txt_mon6"]
                   ,$g_msg_text["com"]["txt_mon7"]
                   ,$g_msg_text["com"]["txt_mon8"]
                   ,$g_msg_text["com"]["txt_mon9"]
                   ,$g_msg_text["com"]["txt_mon10"]
                   ,$g_msg_text["com"]["txt_mon11"]
                   ,$g_msg_text["com"]["txt_mon12"]);

$axisYText = array();
$axisYData = array();
$chartData = array();

for($i = 0; $i < 6; $i++){
    $axisYText[$i] = $arrayAxisYText[$monthText];
    $tmp = str_pad($monthText, 2, "0", STR_PAD_LEFT);
    $axisYData[$i] = $tmp;
    $chartData[$tmp] = 0;
    $monthText++;
    if ($monthText > 12) $monthText = 1;
}

try {
    $g_db->open();

    $isLinux = isOsLinux() ? "true" : "false";

    // 실시간 검사 관련 로직
    if($GLOBALS["feature"]["fanotify"]) {
        $query = "select ifnull(a.realtime_on, 0) as rt_on
              from   realtime a
              where  a.no=1;";
        $rs = $g_db->getrow($query);

        $isSupportFanotify = "true";
        $realtime_on_text = ($rs["rt_on"] == 1 ? $g_msg_text["summ_stts05"]["txt05_1"] : $g_msg_text["summ_stts05"]["txt05_2"]);
        $realtime_btn_style = "xsmall";
    } else {
        $isSupportFanotify = "false";
        $realtime_on_text = $g_msg_text["summ_stts05"]["txt05_3"];
        $realtime_btn_style = "xsmallDisable";
    }

    $query = " select case when (strftime('%s', '".dateNow()."') - strftime('%s', ifnull(last_scan_date, datetime('".dateNow()."', '-2 day')))) < (1*24*60*60) then 1 else 0 end as scan_status "
            ."      , case when (strftime('%s', date('".dateNow()."')) - strftime('%s', ifnull(replace(substr(engine_version, 1, 10), '.', '-'), date('".dateNow()."', '-2 days')))) < (2*24*60*60) then 1 else 0 end as update_status "
            ."      , date(last_scan_date) as last_scan_date "
            ."      , engine_version as engine_version "
            ."      , ifnull(apc_use, 0) as apc_use "
            ."      , case when ( strftime('%s', datetime('now', 'localtime')) - strftime('%s', ifnull(apc_time, datetime(datetime('now', 'localtime'), '-1 day'))) ) < (2*60*60) then 1 else 0 end as apc_status "
            ." from   server_info "
            ." where  no = 1;";
    $rsSumm = $g_db->getrow($query);

    $query=" select count(*) as cnt from statistics;";
    $rs = $g_db->getrow($query);
    $totalVirus = $rs["cnt"];

    $query=" select strftime('%Y%m', time) as yearmon "
          ."       ,strftime('%m', time) as mon "
          ."       ,count(*) as cnt "
          ."       ,sum(case when strftime('%m', time) = strftime('%m', '".dateNow()."') then 1 else 0 end) as moncnt "
          ." from   statistics "
          ." where  date(time) between date('".dateNow()."', 'start of month', '-6 months') and date('".dateNow()."', 'start of month', '+1 months', '-1 days') "
          ." group  by strftime('%Y%m', time) ,strftime('%m', time) "
          ." order  by strftime('%Y%m', time); ";
    $rs = $g_db->queryAll($query);
    foreach($rs as $mon){
        $chartData[$mon["mon"]] = $mon["cnt"];
        $atMonthCnt = intval($mon["moncnt"]);
    }

} catch (Exception $e) {
    /* TODO: */
}

$g_db->close();

if ($rsSumm["scan_status"] == 1 && $rsSumm["update_status"] == 1){
    $summ_ttl01 = "<img src=\"".$IMG_ROOT."icon_state_safe.gif\"> ".$g_msg_text["summ_stts01"]["des01"];
    $summ_btn01_style = "xsmall";
    $summ_btn02_style = "xsmall";
    $summ_ttl01_style = "stateSafe";
}else if ($rsSumm["scan_status"] == 0 && $rsSumm["update_status"] == 1){
    $summ_ttl01 = "<img src=\"".$IMG_ROOT."icon_state_danger.gif\"> ".$g_msg_text["summ_stts02"]["des03"];
    $summ_btn01_style = "xsmallEm";
    $summ_btn02_style = "xsmall";
    $summ_ttl01_style = "stateDanger";
}else if ($rsSumm["scan_status"] == 1 && $rsSumm["update_status"] == 0){
    $summ_ttl01 = "<img src=\"".$IMG_ROOT."icon_state_danger.gif\"> ".$g_msg_text["summ_stts02"]["des02"];
    $summ_btn01_style = "xsmall";
    $summ_btn02_style = "xsmallEm";
    $summ_ttl01_style = "stateDanger";
}else if ($rsSumm["scan_status"] == 0 && $rsSumm["update_status"] == 0){
    $summ_ttl01 = "<img src=\"".$IMG_ROOT."icon_state_danger.gif\"> ".$g_msg_text["summ_stts02"]["des01"];
    $summ_btn01_style = "xsmallEm";
    $summ_btn02_style = "xsmallEm";
    $summ_ttl01_style = "stateDanger";
}

$summ_txt01 = trim($rsSumm["last_scan_date"]);
if (!$summ_txt01) $summ_txt01 = $g_msg_text["summ_stts02"]["txt01_1"];

$summ_txt02 = trim($rsSumm["engine_version"]);
if (!$summ_txt02) $summ_txt02 = $g_msg_text["summ_stts02"]["txt02_1"];

$summ_txt03 = "<p style='height:19px;'>&nbsp;</p>";
$summ_txt03_style="style=\"display:none;\"";
if ($rsSumm["apc_use"] == 1){
    $summ_txt03_style="style=\"display:inline-block;\"";
    if ($rsSumm["apc_status"] == 1){
        $summ_txt03 = "<label>".$g_msg_text["summ_stts03"]["txt03"].":</label> ".$g_msg_text["summ_stts03"]["txt03_1"]." <img src=\"".$IMG_ROOT."icon_connected.gif\" >";
    }
    else{
        $summ_txt03 = "<label>".$g_msg_text["summ_stts03"]["txt03"].":</label> ".$g_msg_text["summ_stts03"]["txt03_2"]." <img src=\"".$IMG_ROOT."icon_disconnected.gif\" >";
    }
}

if(isOsLinux()) {
    $graphAreaStyle = "graphAreaLinux";
    $graphAreaHeight = "height:252px;";
    $axisData = makeAxisX($chartData, 6);
} else {
    $graphAreaStyle = "graphAreaUnix";
    $graphAreaHeight = "height:165px;";
    $axisData = makeAxisX($chartData, 4);
}


$i = 1;
$atLast = sizeof($axisData[0]);
foreach($axisData[0] as $dataValue) {
    if ($atLast == $i) $strAxisY .= "<li class=\"last\">".$dataValue."</li>";
    else $strAxisY .= "<li>".$dataValue."</li>";
    $i++;
}

$noVirusMonth = 0;
foreach($axisData[1] as $dataKey=>$dataValue) {
    if ($dataValue > 0) $noVirusMonth = 0;
    else $noVirusMonth++;
}

if ($totalVirus > 0){
    if ($noVirusMonth > 0) $statistics_info = "<p class=\"text\">".str_replace(array("%1p", "\\\\n", "\\n"), array($noVirusMonth, "<br>", "<br>"), $g_msg_text["summ_vttl01"]["des02"])."</p>";
}
else{
    $statistics_info = "<p class=\"text\">".$g_msg_text["summ_vttl01"]["des01"]."</p>";
}
$monthTextArray = array(1=>$g_msg_text["com"]["txt_mon1"]
                          ,$g_msg_text["com"]["txt_mon2"]
                          ,$g_msg_text["com"]["txt_mon3"]
                          ,$g_msg_text["com"]["txt_mon4"]
                          ,$g_msg_text["com"]["txt_mon5"]
                          ,$g_msg_text["com"]["txt_mon6"]
                          ,$g_msg_text["com"]["txt_mon7"]
                          ,$g_msg_text["com"]["txt_mon8"]
                          ,$g_msg_text["com"]["txt_mon9"]
                          ,$g_msg_text["com"]["txt_mon10"]
                          ,$g_msg_text["com"]["txt_mon11"]
                          ,$g_msg_text["com"]["txt_mon12"]);
$monthCountText = str_replace("%1p", $monthTextArray[$atMon], $g_msg_text["summ_vttl01"]["txt01_1"]);

echo page_start();
echo <<<__HTML_TEXT__
<script language="javascript" type="text/javascript">
//-->
// chrome 의 callback 값을 받기 위해 필요.
function showModalDialogCallback(rtn) {
	if (typeof(rtn) != "undefined" && rtn == "OK") {
        self.location.reload();
    }
}
function showLabel(sMon, isShow){
    if(isShow){
        var barWidth = $("bar"+sMon).clientWidth;
        $("mon" + sMon).style.display = "inline-block";
        var monsLeft = -11;
        if (barWidth > 0){
            var labelWidth = $("mon"+sMon).clientWidth;
            var offsetWidth = Math.floor(barWidth * ( Math.abs(barWidth - labelWidth - 6) / barWidth ) / 2);
            monsLeft = (((barWidth - labelWidth)<0)?-1:1) * offsetWidth;
        }
        if (!isNaN(monsLeft)) $("mon" + sMon).style.left = monsLeft;
    }
    else{
        $("mon" + sMon).style.display = "none";
    }
}
function getLogList(){
    this.LogListRH = function(result){
        $("log_list").innerHTML = result.responseText;
    };
    new Ajax.Request("{$SRC_ROOT}summary_proc.php"
                ,{parameters : {cmd:"get_log"}
                ,onSuccess : this.LogListRH });
}
function openScanDialog(){
	if(scan_type == 1){
		child_window = openPop('{$SRC_ROOT}pop_check.php?cmd=manual_medc','',590,463,'1');
	}
	else if(scan_type == 2){
		child_window = openPop('{$SRC_ROOT}pop_check.php?cmd=resv_medc','',590,463,'1');
	}
	a_tag_block();
	chlid_window_check_timer_start();
}
var isAdd = true;
var scan_type = 2;
var scan_status = 1;

function checkScanning(){
    this.ServerStatusRH = function(result){
		var obj = document.getElementById('ScanTypeID');
        var rtn = eval(result.responseText);
		scan_type = rtn[1];
		scan_status = rtn[0];
		if (scan_type == 1 && scan_status != ___SCAN_STANDBY___){
			obj.innerHTML="<label>{$g_msg_text["summ_stts04"]["txt04"]}:</label>{$g_msg_text["scan"]["ttl01"]}";
            if (isAdd) $("reservScanStatus").show();
            isAdd = false;
		}
		else if (scan_type == 2 && scan_status != ___SCAN_STANDBY___){
			obj.innerHTML="<label>{$g_msg_text["summ_stts04"]["txt04"]}:</label>{$g_msg_text["scan"]["ttl02"]}";
            if (isAdd) $("reservScanStatus").show();
            isAdd = false;
		}
        else{
            $("reservScanStatus").hide();
            isAdd = true;
        }
    }
    new Ajax.Request("{$SRC_ROOT}filescan_cmd.php"
                    ,{parameters : {cmd:"scan_status"}
                    ,onSuccess : this.ServerStatusRH });
}
function initPage(){
    getLogList();
    checkScanning();
    
    // 실시간 검사 관련 로직
    if({$isLinux}) {
        if({$isSupportFanotify}) {
            document.getElementById("realtime_link_setting").setAttribute("href", "{$SRC_ROOT}setting.php");
        } else {
            document.getElementById("realtime_link_setting").removeAttribute("href");
        }
    }
    
    setInterval("checkScanning()", 3000);
}
//-->
</script>
__HTML_TEXT__;

echo page_body("mnu01", "initPage()");
echo <<<__HTML_TEXT__
                <h2>{$g_msg_text["summ"]["ttl01"]}</h2>
                <div class="fl">
                    <div class="block1">
                        <div class="block2"  style="height:165px;">
                            <h3>{$g_msg_text["summ"]["ttl02"]}</h3>
                            <p class="{$summ_ttl01_style}">{$summ_ttl01}</p>
    
                            <div class="stateInfo">
    
                                <div id="statusInfoUL" class="stateInfoList">
                                    <div class="stateInfoListDiv">
                                        <div class="stateInfoListItem"><label>{$g_msg_text["summ_stts02"]["txt01"]}:</label> {$summ_txt01}</div>
                                        <div class="btn btnSet">
                                            <a href="{$SRC_ROOT}filecheck.php" class="button {$summ_btn01_style}"><span class="w81">{$g_msg_text["summ_stts01"]["btn01"]}</span></a>
                                        </div>
                                    </div>
                                    <div class="stateInfoListDiv">
                                        <div class="stateInfoListItem"><label>{$g_msg_text["summ_stts02"]["txt02"]}:</label> {$summ_txt02}</div>
                                        <div class="btn btnSet">
                                            <a href="{$SRC_ROOT}update.php" class="button {$summ_btn02_style}"><span class="w81">{$g_msg_text["summ_stts02"]["btn02"]}</span></a>
                                        </div>
                                    </div>
    
                                    <div style="height:20px;">
                                        <div id="apcStatus" class="stateInfoListDiv" {$summ_txt03_style}>
                                            <div style="margin-top:4px;">{$summ_txt03}</div>
                                        </div>
                                    </div>
    
                                    <div id="reservScanStatus" style="display:none;" class="stateInfoListDiv">
										<div id="ScanTypeID" class="stateInfoListItem"></div>
                                        <div class="btn btnSet" style="margin-top:5px;">
                                            <a href="javascript:;" onclick="javascript:openScanDialog();">{$g_msg_text["summ_stts04"]["txt04_1"]}</a> <img src="{$IMG_ROOT}icon_loading.gif" alt="" border=0 align="absmiddle">
                                        </div>
                                    </div>
                                </div>
    
                            </div>
                        </div>
                        
                    </div>
__HTML_TEXT__;

// 실시간 검사 영역 (Linux에서만 보임)
if(isOsLinux()) {
    echo <<<__HTML_TEXT__
                    <p class="mgb7"></p>
                    <div class="block1">
                        <div class="block2"  style="height:50px;">
                            <h3>{$g_msg_text["summ_stts05"]["txt05"]}</h3>
                            <div class="stateInfo2">
                                <div id="statusInfoUL" class="stateInfoList">
                                    <div class="stateInfoListDiv">
                                        <div class="stateInfoListItem"><label>{$g_msg_text["summ_stts05"]["txt05"]}:</label> {$realtime_on_text}</div>
                                        <div class="btn btnSet">
                                            <a id="realtime_link_setting" class="button {$realtime_btn_style} "><span class="w81">{$g_msg_text["summ_stts05"]["btn01"]}</span></a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
__HTML_TEXT__;
}

echo <<<__HTML_TEXT__
                </div>
                <div class="fr">
                    <div class="block1">
                        <div class="block2" style="{$graphAreaHeight}">
                            <h3>
                                {$g_msg_text["summ"]["ttl03"]}&nbsp; &nbsp;
                                <span>{$monthCountText}: {$atMonthCnt}{$g_msg_text["summ_vttl01"]["txt01_2"]} &nbsp; &nbsp;</span>
                                <span class="detailView"><a href="{$SRC_ROOT}statistics.php">{$g_msg_text["summ"]["lst01"]}</a></span>
                            </h3>
                            <div class="{$graphAreaStyle}">
                                <ul class="sum">
                                    {$strAxisY}
                                </ul>
                                <div class="graph">
                                    <ul>
                                    <li><span class="gTermCrruent"><span onmouseover="javascript:showLabel( '1', true)" onmouseout="javascritp:showLabel( '1', false)">{$axisYText[0]}</span></span><span id="bar1" class="gBar" style="height:{$axisData[1][$axisYData[0]]}%;top:{$axisData[2][$axisYData[0]]}%;"><span id="mon1" style="display:none;"><span class="right">{$chartData[$axisYData[0]]}</span><p class="bl"></p></span></span></li>
                                    <li><span class="gTermCrruent"><span onmouseover="javascript:showLabel( '2', true)" onmouseout="javascritp:showLabel( '2', false)">{$axisYText[1]}</span></span><span id="bar2" class="gBar" style="height:{$axisData[1][$axisYData[1]]}%;top:{$axisData[2][$axisYData[1]]}%;"><span id="mon2" style="display:none;"><span class="right">{$chartData[$axisYData[1]]}</span><p class="bl"></p></span></span></li>
                                    <li><span class="gTermCrruent"><span onmouseover="javascript:showLabel( '3', true)" onmouseout="javascritp:showLabel( '3', false)">{$axisYText[2]}</span></span><span id="bar3" class="gBar" style="height:{$axisData[1][$axisYData[2]]}%;top:{$axisData[2][$axisYData[2]]}%;"><span id="mon3" style="display:none;"><span class="right">{$chartData[$axisYData[2]]}</span><p class="bl"></p></span></span></li>
                                    <li><span class="gTermCrruent"><span onmouseover="javascript:showLabel( '4', true)" onmouseout="javascritp:showLabel( '4', false)">{$axisYText[3]}</span></span><span id="bar4" class="gBar" style="height:{$axisData[1][$axisYData[3]]}%;top:{$axisData[2][$axisYData[3]]}%;"><span id="mon4" style="display:none;"><span class="right">{$chartData[$axisYData[3]]}</span><p class="bl"></p></span></span></li>
                                    <li><span class="gTermCrruent"><span onmouseover="javascript:showLabel( '5', true)" onmouseout="javascritp:showLabel( '5', false)">{$axisYText[4]}</span></span><span id="bar5" class="gBar" style="height:{$axisData[1][$axisYData[4]]}%;top:{$axisData[2][$axisYData[4]]}%;"><span id="mon5" style="display:none;"><span class="right">{$chartData[$axisYData[4]]}</span><p class="bl"></p></span></span></li>
                                    <li><span class="gTermCrruent"><span onmouseover="javascript:showLabel( '6', true)" onmouseout="javascritp:showLabel( '6', false)">{$axisYText[5]}</span></span><span id="bar6" class="gBarCrruent" style="height:{$axisData[1][$axisYData[5]]}%;top:{$axisData[2][$axisYData[5]]}%;"><span id="mon6" style="display:none;"><span class="right">{$chartData[$axisYData[5]]}</span><p class="bl"></p></span></span></li>
                                    </ul>
                                </div>
                                {$statistics_info}
                            </div>
                        </div>
                    </div>
                </div>
                
                <div class="cboth"></div>
                <p class="mgb10"></p>

                <div class="block1">
                    <div class="block3">
                        <h3>
                            {$g_msg_text["summ"]["ttl04"]}&nbsp; &nbsp;
                            <span class="detailView"><a href="{$SRC_ROOT}log.php">{$g_msg_text["summ"]["lst02"]}</a></span>
                        </h3>

                        <table width="744px" cellpadding="0" cellspacing="0" class="list">
                        <colgroup>
                            <col width="20%"></col>
                            <col width="25%"></col>
                            <col width="11%"></col>
                            <col width="11%"></col>
                            <col width="33%"></col>
                        </colgroup>
                        <tr>
                            <th>{$g_msg_text["logm_virs"]["clt01"]}</th>
                            <th>{$g_msg_text["logm_virs"]["clt02"]}</th>
                            <th>{$g_msg_text["logm_virs"]["clt03"]}</th>
                            <th>{$g_msg_text["logm_virs"]["clt06"]}</th>
                            <th>{$g_msg_text["logm_virs"]["clt04"]}</th>
                        </tr>
                        </table>

                        <div id="log_list" style="width:744px; height:200px; background-color:white;" class="tableWrap"></div>
                    </div>
                </div>
__HTML_TEXT__;
echo page_tail();
?>
