/******************************************************************************
 *
 *  (C) 2018 AhnLab, Inc. All rights reserved.
 *  Any part of this source code can not be copied with any method without
 *  prior written permission from the author or authorized person.
 *
 ******************************************************************************/

/**
*  트리를 생성한다.
*
**/
var __AhnLabTreeSelfEvent = new Object();
function AhnLabTree(thisName){
    __AhnLabTreeSelfEvent[thisName] = this;
////////////////////////////////////////////////////////////////////////////////////////////
//  내부 PROTOTYPE 선언
////////////////////////////////////////////////////////////////////////////////////////////
    // 문자열의 양쪽 White 문자들을 삭제한다.
    String.prototype.trim = function(){return this.replace(/^\s*|\s*$/g, "");};
////////////////////////////////////////////////////////////////////////////////////////////
    // 내부의 노드 배열 변수
    this.nList = {};

    // 기본 생성자로 트리 스크립트의 선언시 외부에 선언된 객체명
    this.varName = thisName;

    // 트리가 그려지는 곳의 ID
    this.frameId = "";

    // 브라우져 타입 정의 IE 아니면 기타
    this.isIe = (document.all)?true:false;

    // 신규 노드의 순차 번호(1 이상으로 하자)
    this.nodeKeySeq = 1;

    // 각 노드의 머릿말 정보
    this.nodeHead = "node_";

    // 각 노드의 꼬릿말 정보
    this.nodeTail = {node:"_node", body:"_body", folder:"_folder", check:"_check", icon:"_icon"
                    , label:"_label", text:"_text", textinput:"_textinput", frame:"_frame"};

    this.progId = "node_progress_bar";

    // 내부 이밴트 기록 변수
    this.localEvent = null;

    // root 표현 여부
    this.rootVisible = true;

    // root Text
    this.rootText = "내 컴퓨터";
    this.rootPath = "/";

    // new Text
    this.defaultText = "새 폴더";

    // progress Text
    this.progText = "잠시만 기다려 주십시오.";

    // check box 표현 여부
    this.checkVisible = true;

    // edit 표현여부
    this.editable = false;

    // 선택 여러개
    this.enableMultiSelect = false;

    // 각 노드의 Type(수정 금지)
    this.typeValue = {root:0, group:1, node:2};

    // check 필드의 구분자
    this.checkValue = {no:0, chk:1, some:2};

    // open 필드의 구분자
    this.openValue = {open:1, close:0};

    // 트리를 그릴 곳의 CSS
    this.frameCss = "node_tree";

    this.progCss = "node_prog";

    this.checkCss = {no:"node_check_not", chk:"node_check", some:"node_check_some"};

    this.folderCss = {FOpen:"node_folder_open",     FClose:"node_folder_close",
                      FMiddle:"node_folder_middle", FEnd:"node_folder_end",
                      FOut:"node_folder_out",       FNone:"node_folder_none"};

    // 각 노드 타입별 HTML 표현 CSS 값
    this.nodeCss = [{Node:"node_node",              NBody:"node_body",
                     IcOpen:"node_icon_open",       IcClose:"node_icon_close",
                     SLabel:"node_label_over",      NLabel:"node_label",
                     Text:"node_text",              Frame:"node_frame"},
                    {Node:"node_node",              NBody:"node_body",
                     IcOpen:"node_icon_open",       IcClose:"node_icon_close",
                     SLabel:"node_label_over",      NLabel:"node_label",
                     Text:"node_text",              Frame:"node_frame"},
                    {Node:"node_node",              NBody:"node_body",
                     IcOpen:"node_icon_open",       IcClose:"node_icon_close",
                     SLabel:"node_label_over",      NLabel:"node_label",
                     Text:"node_text",              Frame:"node_frame"}];

    // 폴더 이밴트 ( 외부 ) [전처리 , 후처리]로 구성 return은 treu/false로
    this.eventFunc = { open:[null, null], close:[null, null], edit:[null, null],
                       clickfolder:[null, null],clickicon:[null, null],clicklabel:[null, null],
                       dblclick:[null, null], check:[null, null],
                       blur:[null, null], change:[null, null], keydown:[null, null] };

    // 이밴트 인자 상수 (수정 금지)
    this.eventName = { Addnode:"addnode", Add:"add", Remove:"remove", Clear:"clear", Find:"find",
                       Progress:"progress",
                       getCheckNode:"getchecknode", getSelectNode:"getselectnode", Open:"open", Close:"close", Edit:"edit",
                       ClickFolder:"clickfolder", ClickIcon:"clickicon", ClickLabel:"clicklabel",
                       DblClick:"dblclick", Check:"check",
                       Mouseover:"mouseover", Mouseout:"mouseout",
                       Blur:"blur", Change:"change", Focus:"focus", Keydown:"keydown" };

    // contextMenu의 표시 구분 인덱스
    this.showContext = { root:0, group:0, node:0 };

    // contextMenu의 구성자 배열
    this.contextMenu = [[
          {menuId:this.eventName.Edit, menuText:"이름 바꾸기", menuCmd:""}
          ,{menuId:"-", menuText:"", menuCmd:""}
        ]];

    // 신규로 추가되는 노드 들을 한번에 작성하는 수
    this.maxNewNode = 500;

    // 신규로 추가되는 노드을 정의한 배열을 임시로 할당 하는 변수
    this.addNewNode = [];

    // 노드를 표현 할때 기본으로 체크 상태로 표현되어야 할 노드를 정의하는 변수
    this.checkNode = [];

    // 현재 선택한 노드
    this.selectNode = "";

    // 현재 체크한 노드
    this.checkedNode = "";

    // 파일 구분자
    this.filePath = "/";

    // 선택 구분자
    this.selectPath = "|";

    // 아이디 구분자
    this.treeIdPath = ";";

    // 선택 문자열에 추가
    this.addSelect = function(s, w){
        var isAdd = (s.indexOf(w + this.selectPath) >= 0);
        if (!isAdd) return s + w + this.selectPath;
        else return s;
    };

    // 선택 문자열에 삭제
    this.delSelect = function(s,w){
        var startIndex = s.indexOf(w + this.selectPath);
        if (startIndex >= 0){
            return s.substring(0, startIndex) + s.substring(startIndex + ((w + this.selectPath).length -1));
        }
        else return s;
    };

    // 노드의 각 세부 이름 정보
    this.getNodeName = function (id){
        var rtn = new Object();
        rtn.Node = this.nodeHead + id + this.nodeTail.node;
        rtn.NBody = this.nodeHead + id + this.nodeTail.body;
        rtn.Folder = this.nodeHead + id + this.nodeTail.folder;
        rtn.Check = this.nodeHead + id + this.nodeTail.check;
        rtn.Icon = this.nodeHead + id + this.nodeTail.icon;
        rtn.Label = this.nodeHead + id + this.nodeTail.label;
        rtn.Text = this.nodeHead + id + this.nodeTail.text;
        rtn.TInput = this.nodeHead + id + this.nodeTail.textinput;
        rtn.Frame = this.nodeHead + id + this.nodeTail.frame;
        return rtn;
    };

    // 노드의 아이디 가져오기
    this.getNodeId = function (sId){
       var rtn;
       var tmp = sId;
       if (tmp.indexOf(this.nodeHead) < 0){
           rtn = tmp;
       }
       else{
           tmp = tmp.substr(this.nodeHead.length);
           rtn = tmp.substring(0, tmp.lastIndexOf("_"));
       }
       return rtn;
    };

    // 개채 가져오기
    this.getDom = function(sId){return document.getElementById(sId);};

    // 해당 개체의 표시
    this.objectShow = function(obj){obj.style.display="block";};

    // 해당 개체의 숨김
    this.objectHide = function(obj){obj.style.display="none";};

    // 개체의 택스트 값 가져오기
    this.getText = function(obj){
        var sText = "";
        if (obj.tagName.toUpperCase() == "INPUT") sText = obj.value;
        else sText = (obj.innerText)?obj.innerText:obj.text;
        return sText.trim();
    };

    // 개체의 텍스트 설정하기(불안한)
    this.setText = function(obj, value){
        if (obj.tagName.toUpperCase() == "INPUT") obj.value = value;
        else {
            if (obj.innerText){
                obj.innerText = value;
            }else{
                obj.innerHTML = value;
            }
        }
    };

    // 이밴트의 속성값을 재정의하는 함수(인자값은 이밴트)
    this.getEvent = function(evt){
        var objEvent = new Object();// {E:null, X:0, Y:0, button:0};
        objEvent = (window.event)? window.event : evt;
        if (objEvent == null) return null;
        objEvent.element = (window.event)?window.event.srcElement:evt.target;
        if (objEvent.pageX == null) {
            var d= (document.documentElement && document.documentElement.scrollLeft != null) ? document.documentElement : document.body;
            objEvent.mouseX= objEvent.clientX + d.scrollLeft;
            objEvent.mouseY= objEvent.clientY + d.scrollTop;
        }
        else {
            objEvent.mouseX= objEvent.pageX;
            objEvent.mouseY= objEvent.pageY;
        }
        if (objEvent.which == null){
            objEvent.btn= (objEvent.button < 2) ? 1 : ((objEvent.button == 4) ? 0 : 2);
        }else{
            objEvent.btn= (objEvent.which < 2) ? 1 : ((objEvent.which == 2) ? 0 : 2);
        }
        return objEvent;
    };

    // 이밴트 등록 함수
    this.addEventHandler = function(obj, evtName, func){
        if (obj.attachEvent) obj.attachEvent("on"+evtName, func);
        else if (obj.addEventListener) obj.addEventListener(evtName, func, true);
        else obj['on'+evtName] = func;
    };

    // 이밴트 해제 함수
    this.removeEvnetHandler = function(obj, evtName, func){
        if (obj.detachEvent) obj.detachEvent("on"+evtName, func);
        else if (obj.removeEventListener) obj.removeEventListener(evtName, func, true);
        else obj['on'+evtName] = null;
    };

    // 트리의 이밴트 기록함수
    this.riseEvent = function(evt) {this.localEvent = this.getEvent(evt);};

    // 메시지 띄우기
    this.msgWin = function(msg){alert(msg);};

    // 컨텍스트 메뉴의 프래임 아이디
    this.ContextId = {};
    this.ContextId.Set = function(s){
        this.Body = s + "_ContBody";
        this.List = s + "_ContList";
        this.Item = s + "_ContItem";
    };

    // contextMenu의 프래임 HTML
    this.makeContext = function(){
        // style=\"position:absolute; left:0px; top:0px;visibility:hidden; z-index:200;\"
        this.ContextId.Set(this.frameId);
        return "<div id=\""+ this.ContextId.Body +"\" class=\"contMenuBody\">" +
                "<div class=\"contMenu\"><div class=\"contMenuInner\"><ul id=\"" +
                this.ContextId.List +"\" ></ul></div></div></div>";
    };

    // contextMenu를 생성한다. 인자값은 위에서 정의된 노드의 타입(루트, 그룹, 자식)별 인덱스이다.
    this.makeContextMenu = function(sId){
        var contMenu = 0;
        var nodeId = this.getNodeId(sId);
        var actNodeName = this.getNodeName(nodeId);
        var oItemactNode = this.getDom(this.ContextId.Body);

        if (!this.nList[nodeId]) return false;

        if (this.nList[nodeId].type == this.typeValue.root && this.showContext.root < 1) return false;
        else contMenu = this.showContext.root;
        if (this.nList[nodeId].type == this.typeValue.group && this.showContext.group < 1) return false;
        else contMenu = this.showContext.group;
        if (this.nList[nodeId].type == this.typeValue.node && this.showContext.node < 1) return false;
        else contMenu = this.showContext.node;

        var contenxtList = this.getDom(this.ContextId.List);
        contenxtList.innerHTML = "";

        var rtnMenu = "";
        var mItem;

        var menuLength = this.contextMenu[contMenu].length;
        for (var i=0; i < menuLength; i++){
            mItem = this.contextMenu[contMenu][i];
            if (mItem.menuId.toLowerCase() == "-"){
                if ((i+1) < menuLength){
                    if (this.contextMenu[contMenu][i+1].menuText.trim() != "") rtnMenu += "<li class=\"bar\">&nbsp;</li>";
                }
            }
            else{
                if (mItem.menuText.trim() != ""){
                    rtnMenu += "<li id=\"" + this.ContextId.Item + "\" onclick=\"javascript:";
                    if (mItem.menuId.toLowerCase() != ""){
                        rtnMenu += this.varName + ".treeAction('"+mItem.menuId+"', '"+nodeId+"')";
                    }
                    else{
                        rtnMenu += mItem.menuCmd+"('"+nameInfo.nodeNode+"')";
                    }
                    rtnMenu += ";\">"+mItem.menuText+"</li>";
                }
            }
        }
        contenxtList.innerHTML = rtnMenu;
        return true;
    };
    // contextMenu 보이기
    this.contextMenuShow = function(X, Y){
        document.oncontextmenu = function(){return false;};
        var contextNode = this.getDom(this.ContextId.Body);
        Y = ((Y + contextNode.clientHeight) > window.innerHeight)? window.innerHeight - contextNode.clientHeight : Y;
        contextNode.style.left = X + "px";
        contextNode.style.top = Y + "px";
        contextNode.style.visibility = "visible";
    };
    // contextMenu숨기기
    this.contextMenuForceHide = function(){
        this.getDom(this.ContextId.Body).style.visibility = "hidden";
    };

    // 트리의 메인 프래임
    this.makeTreeBody = function(){
        var nodeIds = this.getNodeName(this.frameId);
        var cssType = this.nodeCss[0];
        return "<div id=\"" + nodeIds.Node + "\" class=\"" + cssType.Node + "\"><div id=\"" + nodeIds.Frame + "\" class=\"" + cssType.Frame + "\"></div></div>";
    };

    // 노드 HTML 그리기
    this.makeNodeUI = function(sId, oItem){
        var nId = this.getNodeId(sId);
        var nodeIds = this.getNodeName(nId);
        var cssType = this.nodeCss[oItem.css];
        var rtn = "";

        rtn += "<div id=\""+ nodeIds.Node +"\" class=\"" + cssType.Node + "\" ";
        rtn += "onmousedown=\"javascript:" + this.varName +".riseEvent(event);\" ";
        rtn += ">";

        rtn += "<table id=\"" + nodeIds.NBody + "\" class=\"" + cssType.NBody + "\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr>";
        var arrDepth = this.nodeDepth(sId);
        var depthLen = arrDepth.length;
        var i, tId, childLen;
        for (i = 0; i < depthLen; i++){
            if (i == (depthLen-1)) {
                rtn += "<td id=\"" + nodeIds.Folder + "\" class=\"" + ((oItem.open == this.openValue.close && !oItem.isChild)?this.folderCss.FOpen:this.folderCss.FClose) + "\" ";
                if (oItem.isChild) rtn += "onclick=\"javascript:" + this.varName +".treeAction('"+ this.eventName.ClickFolder +"', '"+ nodeIds.Node +"');\" ";
                rtn += "></td>";
            }
            else rtn += "<td id=\"folder\" class=\"" + this.folderCss.FNone + "\"></td>";
        }

        rtn += "<td " + ((this.checkVisible == true)?"":"style=\"display:none;\"");
        rtn += "onclick=\"javascript:" + this.varName +".treeAction('"+ this.eventName.Check +"', '"+ nodeIds.Node +"');\" ";
        rtn += "><div id=\"" + nodeIds.Check + "\" class=\""+ ((oItem.check == this.checkValue.chk)?this.checkCss.chk:((oItem.check == this.checkValue.some)?this.checkCss.some:this.checkCss.no)) +"\">&nbsp;</div></td>";

        rtn += "<td id=\"" + nodeIds.Icon + "\" class=\""+ (oItem.open?cssType.IcOpen:cssType.IcClose) +"\" "
        if (oItem.isChild) rtn += "onclick=\"javascript:" + this.varName +".treeAction('"+ this.eventName.ClickIcon +"', '"+ nodeIds.Node +"');\" ";
        rtn += "></td>";

        rtn += "<td id=\"" + nodeIds.Label + "\" class=\""+ cssType.NLabel +"\" "
        rtn += "onclick=\"javascript:" + this.varName +".treeAction('"+ this.eventName.ClickLabel +"', '"+ nodeIds.Node +"');\" ";
        rtn += "ondblclick=\"javascript:" + this.varName +".treeAction('"+ this.eventName.DblClick +"', '"+ nodeIds.Node +"');\" ";
        rtn += "onmouseover=\"javascript:" + this.varName +".treeAction('"+ this.eventName.Mouseover +"', '"+ nodeIds.Node +"');\" ";
        rtn += "onmouseout=\"javascript:" + this.varName +".treeAction('"+ this.eventName.Mouseout +"', '"+ nodeIds.Node +"');\" ";
        rtn += ((oItem.edit)?"style=\"display:none;\"":"");
        rtn += " title=\""+((oItem.memo=="")?oItem.name:oItem.memo)+"\">" + oItem.name + "</td>";

        rtn += "<td id=\"" + nodeIds.Text + "\" style=\"display:none;\">";
        rtn += "<input type=\"text\" id=\"" + nodeIds.TInput + "\" class=\""+ cssType.Text +"\" value=\""+ oItem.name +"\" ";
        rtn += "onkeydown=\"javascript:" + this.varName +".treeAction('"+ this.eventName.Keydown +"', '"+ nodeIds.Node +"');\" ";
        rtn += "onblur=\"javascript:" + this.varName +".treeAction('"+ this.eventName.Blur +"', '"+ nodeIds.Node +"');\" ";
        rtn += "onchange=\"javascript:" + this.varName +".treeAction('"+ this.eventName.Change +"', '"+ nodeIds.Node +"');\" ";
        rtn += "onfocus=\"javascript:" + this.varName +".treeAction('"+ this.eventName.Focus +"', '"+ nodeIds.Node +"');\" ";
        rtn += "/></td>";

        rtn += "</tr></table></div>";

        rtn += "<div id=\"" + nodeIds.Frame + "\" class=\""+ cssType.Frame +"\"></div>";

        return rtn;
    };
    //프로그래스 표현
    this.makeProgressUI = function(){
        var rtn = "";
        rtn += "<div id=\""+this.progId+"\" class=\""+this.progCss+"\" style=\"display:none;\">";
        rtn += "<table width=\"100%\" height=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
        rtn += "<tr><td valign=\"middle\" align=\"center\" style=\"line-height:150%;\">"+this.progText+"</td></tr>";
        rtn += "</table></div>";
        return rtn;
    }
    // 노드 생성
    this.create = function(p,f,a,n,t,c,o,e,s,l,k,m){
            return { pid:p ,fid:f ,path:a ,name:n ,type:t ,check:c ,open:o
                    ,edit:e ,css:s  ,child:l, isChild:k, memo:m };
        };
    // 노드 값 가져오기
    this.getNode = function(fid){return this.nList[fid]};

    // 노드 추가
    this.addList = function(oItem){
        if (oItem.fid == "") oItem.fid = this.makeNewNodeId(oItem.pid, true);
        this.nList[oItem.fid]=oItem;
        if (typeof(this.nList[oItem.pid]) != "undefined"){
            var childLen = this.nList[oItem.pid].child.length;
            this.nList[oItem.pid].child[childLen] = oItem.fid;
            this.nList[oItem.pid].isChild = true;
        }
        return oItem.fid;
    };
    // 노드 삭제
    this.delList = function(oItem){
            var childLen = this.nList[oItem.pid].child.length;
            var tmp;
            for(var i=0; i < childLen; i++){
                if (this.nList[oItem.pid].child[i] == oItem.fid){
                    tmp = this.nList[oItem.pid].child.slice(i, 1);
                    break;
                }
            }
            this.nList[oItem.pid].child = tmp;
            this.nList[oItem.pid].isChild = (this.nList[oItem.pid].child.length>0);
            try{
                delete(this.nList[oItem.fid]);
            }catch(e){}
        };
    // 노드 변경
    this.upList = function(oItem){
            return this.nList[oItem.fid] = oItem;
        };
    // 노드 path 경로 찾기
    this.getPath = function(fId){
        var sPath = "";
        fId = this.getNodeId(fId);
        do{
            if (this.nList[fId]) {
                if (this.nList[fId].pid!="") sPath = this.filePath + this.nList[fId].path + sPath;
                else sPath = ((sPath=="")?this.rootPath:"") + sPath;
                fId = this.nList[fId].pid;
            }
            else fId = "";
        }while(fId != "");
        return sPath;
    };
    // 트리 구조 그리기
    this.treeNodeLeaf = function(cId, TDs, tdIndex, isFirst){
        var pId, pItem, pLen, ppItem, ppLen;
        pId = this.nList[cId].pid;
        if (pId != ""){
            pItem = this.nList[pId];
            pLen = pItem.child.length;
            if (pItem.pid == ""){
                if (isFirst && pItem.child[0] == cId) {
                    TDs[tdIndex].className = (!this.rootVisible && pItem.fid == this.getRootId())?this.folderCss.FNone:this.folderCss.FEnd;
                }
                else {
                    TDs[tdIndex].className = this.folderCss.FNone;
                }
            }
            else{
                if (pItem.child[(pLen -1)] == cId){
                    TDs[tdIndex].className = (isFirst)?this.folderCss.FEnd:this.folderCss.FNone;
                }
                else if (pItem.child[0] == cId){
                    TDs[tdIndex].className = (isFirst)?this.folderCss.FMiddle:this.folderCss.FOut;
                }
                else{
                    TDs[tdIndex].className = (isFirst)?this.folderCss.FMiddle:this.folderCss.FOut;
                }
            }
        }
        if (tdIndex > 0) this.treeNodeLeaf(pId, TDs, (tdIndex-1), false);
    }
    // tree의 처리 함수
    this.treeProcess = function(sAct){
        var rootNode = null;
        var rootFrame = null;
        var i,j,m,n,s,len;
        var tmp, rtn, ptr;
        var actNode, actNodeId, actNodeName, aLen, actCheck, actFolder, actIcon, actLabel, actText ;
        var pId, parentIds, parentNode, pLen;
        var cId, childIds, childNode, cLen;
        var childBody, childBodyTds, cbLen;
        switch(sAct.toLowerCase()){
        // Addnode를 통해서 현재 표현되어야 할 정보를 미리 등록하고 화면에 표현한다.(Add 호출)
        // pid, isChild, fid, path, name, type, check, open, edit, cssType
        case this.eventName.Addnode:
            if (arguments.length > 1){
                actNode = arguments[1];
                if (typeof(actNode.pid) == "undefined" || actNode.pid == "") actNode.pid = this.getRootId();
                if (typeof(actNode.fid) == "undefined" ) actNode.fid = "";
                if (typeof(actNode.name) == "undefined" || actNode.name == "") actNode.name = this.defaultText;
                if (typeof(actNode.path) == "undefined" || actNode.path == "") actNode.path = actNode.name;
                if (typeof(actNode.type) == "undefined" || actNode.type == "") actNode.type = this.typeValue.group;
                if (typeof(actNode.check) == "undefined" || actNode.check == "") actNode.check = this.checkValue.no;
                if (typeof(actNode.open) == "undefined" || actNode.open == "") actNode.open = this.openValue.close;
                if (typeof(actNode.edit) == "undefined" || actNode.edit == "") actNode.edit = false;
                if (typeof(actNode.css) == "undefined" || actNode.css == "") actNode.css = 1;
                if (typeof(actNode.child) != "object") actNode.child = [];
                if (typeof(actNode.isChild) == "undefined") actNode.isChild = true;
                if (typeof(actNode.memo) == "undefined") actNode.memo = "";
            }
            else{
                actNode = this.create("", this.getRootId(), "", this.rootText, this.typeValue.root, this.checkValue.no,
                            this.openValue.close, false, 0, [], true, "");
            }
            //this.addNewNode[this.addNewNode.length] = actNode;
            i = this.addNewNode.length;
            for(tmp in this.addNewNode){
                if (this.addNewNode[tmp].pid == actNode.pid && this.addNewNode[tmp].name >= actNode.name){
                    i = tmp;
                    break;
                }
            }
            this.addNewNode.splice(i,0,actNode);
            break;
        // 노드를 추가한다. 우선 this.addNewNode 변수에 배열로 값을 할당 해야 한다.
        case this.eventName.Add:
            j = (arguments.length > 1)?arguments[1]:0;
            len = this.addNewNode.length;
            actCheck = new Array();
            for(i=j; i < len; i++){
                if (i >= (j + this.maxNewNode)) {
                    setTimeout(varName+".treeProcess('"+ sAct +"', " + (j + this.maxNewNode) + ")", 1);
                    break;
                }
                tmp = this.addNewNode[(i+j)];
                s = true;
                if (this.nList[tmp.pid]){
                    // 경로 중복 제거
                    childNode = this.nList[tmp.pid].child;
                    clen = childNode.length;
                    for(m=0; m<clen; m++){
                        if (this.nList[childNode[m]].name == tmp.name) {
                            s = false;
                            break;
                        }
                    }
                }
                if (s){
                    tmp.fid = this.addList(tmp);
                    pId = tmp.pid;
                    parentNode = this.nList[pId];
                    if (parentNode && parentNode.check == this.checkValue.chk) {
                        tmp.check = this.checkValue.chk;
                    }
                    if (tmp.check != this.checkValue.no) this.checkedNode = this.addSelect(this.checkedNode, tmp.fid);
                    rootFrame = this.getNodeName( ((tmp.pid == "")?this.frameId:this.getNodeId(tmp.pid)) );
                    rootNode = this.getDom(rootFrame.Frame);
                    n = this.getNodeName(tmp.fid);
                    rootNode.innerHTML += this.makeNodeUI(n.Node, tmp);
                    if (this.nList[tmp.pid] && this.nList[tmp.pid].open == this.openValue.open) {
                        this.treeProcess(this.eventName.Open, tmp.pid, false);
                    }
                    if (tmp.open == this.openValue.open) this.objectShow(this.getDom(n.Frame));
                }
            }
            if ((i+j) >= len) {
                len = this.addNewNode.length;
                for(i = 0; i < len; i++){
                    if (this.addNewNode[i].chkeck) {
                        this.treeProcess("checkafter", this.addNewNode[i].fid, this.nList[this.addNewNode[i].fid].check, -1);
                        this.treeProcess("checkafter", this.addNewNode[i].fid, this.nList[this.addNewNode[i].fid].check, 1);
                    }
                }
                this.addNewNode = [];
            }
            break;
        case this.eventName.Remove:
            break;
        case this.eventName.Clear:
            actNodeName = this.getNodeName(this.getRootId());
            this.getDom(actNodeName.Frame).innerHTML = "";
            parentNode = this.nList[this.getRootId()];
            this.nList = new Object();
            parentNode.child = [];
            parentNode.isChild = false;
            this.nList[this.getRootId()] = parentNode;
            break;
        case this.eventName.Open:
            if (arguments.length < 2) return;
            actNodeId = this.getNodeId(arguments[1]);
            if (this.nList[actNodeId]){
                this.nList[actNodeId].open = this.openValue.close;
                this.treeProcess(this.eventName.ClickFolder, actNodeId);
            }
            break;
        case this.eventName.Close:
            if (arguments.length < 2) return;
            actNodeId = this.getNodeId(arguments[1]);
            if (this.nList[actNodeId]){
                this.nList[actNodeId].open = this.openValue.open;
                this.treeProcess(this.eventName.ClickFolder, actNodeId);
            }
            break;
        case this.eventName.ClickFolder:
        case this.eventName.ClickIcon:
            if (arguments.length < 2) return;
            actNodeId = this.getNodeId(arguments[1]);
            n = (arguments.length < 3)? (arguments[2] || false): true;
            actNodeName = this.getNodeName(actNodeId);
            actNode = this.getDom(actNodeName.Frame);
            actFolder = this.getDom(actNodeName.Folder);
            actIcon = this.getDom(actNodeName.Icon);
            if ((this.nList[actNodeId] != null) && (this.nList[actNodeId] != null) && (this.nList[actNodeId].child.length > 0) ){
                if (this.nList[actNodeId].open == this.openValue.open) {
                    this.objectHide(actNode);
                    this.nList[actNodeId].open = this.openValue.close;
                    actFolder.className = this.folderCss.FClose;
                    actIcon.className = this.nodeCss[this.nList[actNodeId].css].IcClose;
                }
                else if (this.nList[actNodeId].open == this.openValue.close) {
                    this.objectShow(actNode); // 열리는 노드 보이기
                    this.nList[actNodeId].open = this.openValue.open; // 속성값 설정.
                    actFolder.className = this.folderCss.FOpen;
                    actIcon.className = this.nodeCss[this.nList[actNodeId].css].IcOpen;

                    pId = this.nList[actNodeId].pid;
                    parentNode = this.nList[pId];
                    if (parentNode) pLen = parentNode.child.length;
                    else pLen = 0;

                    cLen = this.nList[actNodeId].child.length;
                    for(i=0; i < cLen; i++){// 하위 노드 변경
                        cId = this.nList[actNodeId].child[i]; // 하위 노드의 아이디
                        childIds = this.getNodeName(cId); // 하위 노드의 이름들
                        if (n){
                            childNode = this.getDom(childIds.Frame);
                            if (childNode) {
                                this.objectHide(this.getDom(childIds.Frame)); // 하위 노드의 하위가 있으면 숨기자.
                                this.nList[cId].open = this.openValue.close;
                            }
                        }
                        if (this.nList[cId].isChild){
                            this.getDom(childIds.Folder).className = this.folderCss.FClose;
                        }
                        else{
                            if (i == (cLen -1)){
                                this.getDom(childIds.Folder).className = this.folderCss.FOpen;
                            }
                            else
                            {
                                this.getDom(childIds.Folder).className = this.folderCss.FOpen;
                            }
                        }

                        if (this.nList[cId].pid != ""){
                            childBody = this.getDom(childIds.NBody); // 트리 구성
                            childBodyTds = childBody.getElementsByTagName("TD");
                            cbLen = childBodyTds.length;
                            this.treeNodeLeaf(cId, childBodyTds, cbLen-6, true);
                        }
                    }
                }
            }
            break;
        case this.eventName.ClickLabel:
            if (arguments.length < 2) return;
            if (this.selectNode.length > 0){
                parentIds = this.selectNode.split(this.selectPath);
                pLen = parentIds.length;
                for(i = 0; i < pLen; i++){
                    if (parentIds[i] != ""){
                        actNodeName = this.getNodeName(parentIds[i]);
                        parentNode = this.getDom(actNodeName.Label);
                        if (!this.enableMultiSelect || !this.localEvent.ctrlKey){
                            parentNode.className = this.nodeCss[this.nList[parentIds[i]].css].NLabel;
                        }
                    }
                }
            }
            actNodeId = this.getNodeId(arguments[1]);
            actNodeName = this.getNodeName(actNodeId);
            actLabel = this.getDom(actNodeName.Label);
            actLabel.className = this.nodeCss[this.nList[actNodeId].css].SLabel;
            if (!this.enableMultiSelect || !this.localEvent.ctrlKey) this.selectNode = "";
            this.selectNode += actNodeId + this.selectPath;
            rtn = this.selectNode;
            break;
        case this.eventName.Check:
            if (arguments.length < 2) return;
            m = (arguments.length > 2)?(arguments[2] && true):false;
            s = (arguments.length > 3)?(arguments[3] == this.checkValue.chk):true;
            actNodeId = this.getNodeId(arguments[1]);
            actNodeName = this.getNodeName(actNodeId);
            actCheck = this.getDom(actNodeName.Check);
            n = (m)?((s)?this.checkValue.no:this.checkValue.chk):this.nList[actNodeId].check;
            if (n == this.checkValue.chk){
                this.nList[actNodeId].check = this.checkValue.no;
                if (actCheck) actCheck.className = this.checkCss.no;
                this.checkedNode = this.delSelect(this.checkedNode, actNodeId);
            }
            else{
                this.nList[actNodeId].check = this.checkValue.chk;
                if (actCheck) actCheck.className = this.checkCss.chk;
                this.checkedNode = this.addSelect(this.checkedNode, actNodeId);
            }

            this.treeProcess("checkafter", actNodeId, this.nList[actNodeId].check, -1);
            this.treeProcess("checkafter", actNodeId, this.nList[actNodeId].check, 1);
            break;
        case "checkafter":
            if (arguments.length < 4) return;
            actNodeId = this.getNodeId(arguments[1]);
            tmp = arguments[2];
            j = arguments[3];
            if (j > 0){
                // 상위로 이동 하면서 체크 값 수정
                pId = this.nList[actNodeId].pid;
                if (pId == "") return;
                cLen = this.nList[pId].child.length;
                s = true;
                n = true;
                for(i = 0; i < cLen; i++){
                    cId = this.nList[pId].child[i];
                    if (this.nList[cId].check != this.checkValue.chk) s = false;
                    if (this.nList[cId].check != this.checkValue.no) n = false;
                }
                parentIds = this.getNodeName(pId);
                parentNode = this.getDom(parentIds.Check);
                if (s){
                    this.nList[pId].check = this.checkValue.chk;
                    parentNode.className = this.checkCss.chk;
                    this.checkedNode = this.addSelect(this.checkedNode, pId);
                }
                else if (n){
                    this.nList[pId].check = this.checkValue.no;
                    parentNode.className = this.checkCss.no;
                    this.checkedNode = this.delSelect(this.checkedNode, pId);
                }
                else{
                    this.nList[pId].check = this.checkValue.some;
                    parentNode.className = this.checkCss.some;
                    this.checkedNode = this.addSelect(this.checkedNode, pId);
                }

                this.treeProcess("checkafter", pId, tmp, j);
            }
            else{
                // 하위로 이동 하면서 체크 값 수정
                cLen = this.nList[actNodeId].child.length;
                for(i = 0; i < cLen; i++){
                    cId = this.nList[actNodeId].child[i];
                    this.nList[cId].check = tmp;
                    childIds = this.getNodeName(cId);
                    childNode = this.getDom(childIds.Check);
                    if (childNode) childNode.className = (tmp == this.checkValue.chk)?this.checkCss.chk:this.checkCss.no;
                    this.checkedNode = (tmp == this.checkValue.chk)?this.addSelect(this.checkedNode, cId):this.delSelect(this.checkedNode, cId);
                    this.treeProcess("checkafter", cId, tmp, j);
                }
            }
            break;
        case this.eventName.getSelectNode:
            rtn = "";
            if (this.selectNode.length > 0) {
                tmp = this.selectNode.split(this.selectPath);
                len = tmp.length;
                for(i = 0; i < len; i++){
                    if (tmp[i] != ""){
                        rtn += this.selectPath + this.getPath(tmp[i]);
                    }
                }
                rtn = rtn.substring(1);
            }
            break;
        case this.eventName.getCheckNode:
            s = (arguments.length > 1)?(arguments[1] && true):false; //false면 모든 선택 폴더 "|" 구분 "=" 로 선택 비선택 구분
            n = (arguments.length > 2)?(arguments[2] && true):false; //false면 모든 선택 폴더만
            tmp = this.checkedNode.split( this.selectPath );
            len = tmp.length;
            rtn = "";
            childIds = new Array();
            if (tmp){
                for(i = 0; i < len; i++){
                    if (!this.rootVisible && tmp[i] == this.getRootId()) i++;
                    if (this.nList[tmp[i]]) {
                        cId = this.getPath(tmp[i]);
                        if (s){
                            if ( this.nList[tmp[i]].check == this.checkValue.chk ) {
                                if (n){
                                    actNode = cId + ((tmp[i] == this.getRootId())?"":this.filePath);
                                    cLen = childIds.length;
                                    actFolder = new Array();
                                    for(j=0; j < cLen; j++){
                                        actCheck = childIds[j] + ((childIds[j] == this.getPath(this.getRootId()))?"":this.filePath);
                                        if (actCheck.indexOf(actNode) < 0) actFolder[actFolder.length] = childIds[j];
                                    }

                                    cLen = actFolder.length;
                                    childNode = true;
                                    for(j=0; j < cLen; j++){
                                        actCheck = actFolder[j] + ((actFolder[j] == this.getPath(this.getRootId()))?"":this.filePath);
                                        if (actNode.indexOf(actCheck) == 0) {
                                            childNode = false;
                                            break;
                                        }
                                    }
                                    if ( childNode ) actFolder[actFolder.length] = cId;
                                    childIds = actFolder;
                                }
                                else{
                                    childIds[childIds.length] = cId;
                                }
                            }
                        }
                        else{
                            childIds[childIds.length] = cId + "=" + this.nList[tmp[i]].check;
                        }
                    }
                }
            }
            rtn = (childIds.length>0)?childIds.join(this.selectPath) + this.selectPath:"";
            if (rtn.length > 0) rtn = rtn.slice(0, -1);
            break;
        case this.eventName.Mouseover:
            if (arguments.length < 2) return;
            actNodeId = this.getNodeId(arguments[1]);
            actNodeName = this.getNodeName(actNodeId);
            actNode = this.getDom(actNodeName.Label);
            actNode.className = this.nodeCss[this.nList[actNodeId].css].SLabel;
            break;
        case this.eventName.Mouseout:
            if (arguments.length < 2) return;
            actNodeId = this.getNodeId(arguments[1]);
            if (this.selectNode.search(actNodeId) == -1){
                actNodeName = this.getNodeName(actNodeId);
                actNode = this.getDom(actNodeName.Label);
                actNode.className = this.nodeCss[this.nList[actNodeId].css].NLabel;
            }
            break;
        case this.eventName.Edit:
            if (!this.editable) return;
            if (arguments.length < 2) return;
            actNodeId = this.getNodeId(arguments[1]);
            actNodeName = this.getNodeName(actNodeId);
            actText = this.getDom(actNodeName.Text);
            actNode = this.getDom(actNodeName.TInput);
            actLabel = this.getDom(actNodeName.Label);
            this.objectHide(actLabel);
            this.objectShow(actText);
            this.contextMenuForceHide();
            actNode.select();
            break;
        case this.eventName.Change:
        case this.eventName.Blur:
            if (!this.editable) return;
            if (arguments.length < 2) return;
            actNodeId = this.getNodeId(arguments[1]);
            actNodeName = this.getNodeName(actNodeId);
            actText = this.getDom(actNodeName.Text);
            actNode = this.getDom(actNodeName.TInput);
            actLabel = this.getDom(actNodeName.Label);
            if (this.nList[actNodeId].name != actNode.value){
                this.nList[actNodeId].name = actLabel.innerText = actLabel.title = actNode.title = actNode.value;
            }
            this.objectHide(actText);
            this.objectShow(actLabel);
            break;
        case this.eventName.Find:
            if (arguments.length < 2) return "";
            actNodeId = new String(arguments[1]);
            if (actNodeId == "") return "";
            cId = this.getRootId();
            rtn = new Array();
            childIds = actNodeId.split(this.filePath);
            cLen = childIds.length;
            i = 1;
            parentNode = "";

            if (cLen > 1){
                do{
                    parentIds = this.nList[cId].child;
                    pLen = parentIds.length;
                    childNode = false;
                    for(m = 0; m < pLen; m++){
                        if (this.nList[parentIds[m]].path == childIds[i]){
                            childNode = true;
                            cId = parentIds[m];
                            parentNode += this.filePath + this.nList[cId].path;
                            i++;
                            break;
                        }
                    }
                    if (parentNode == actNodeId) childNode = false;
                }while(childNode);
            }
            rtn[0] =  cId;
            rtn[1] = ( parentNode == "" )?this.rootPath:parentNode;
            rtn[2] = (i < cLen)? rtn[1] : "";
            for(;i < cLen;i++){
                rtn[2] = rtn[2] + this.filePath + childIds[i];
            }
            break;
        case this.eventName.Progress:
            if (arguments.length < 2) actNodeId = false;
            else actNodeId = arguments[1];
            actNode = this.getDom(this.progId);
            if (actNodeId){
                parentNode = this.getFrame();
                var pos = this.findObjPos(parentNode);
                actNode.style.left = pos[0] + "px";
                actNode.style.top = pos[1] + "px";
                actNode.style.width = parentNode.clientWidth + "px";
                actNode.style.height = parentNode.clientHeight + "px";
                this.objectShow(actNode);
            }
            else{
                this.objectHide(actNode);
            }
            break;
        }
        return rtn;
    };
    this.findObjPos = function(obj) {
        var curleft = curtop = 0;
        if (obj.offsetParent) {
            do {
                curleft += obj.offsetLeft;
                curtop += obj.offsetTop;
            } while (obj = obj.offsetParent);
        }
        return [curleft,curtop];
    }
    this.checkDirs = function(){
        var argu1 = (arguments.length > 0)?(arguments[0] && true):false;
        var argu2 = (arguments.length > 1)?(arguments[1] && true):false;
        return this.treeProcess(this.eventName.getCheckNode, argu1, argu2).trim();
    }
    this.selectDirs = function(){
        return this.treeProcess(this.eventName.getSelectNode).trim();
    }
    this.progress = function(isShow){
        this.treeProcess(this.eventName.Progress,isShow);//((isShow)?"0":null));
    };
    // tree의 이밴트 처리 함수
    this.treeAction = function(sAct, nodeId){
        var rtn;
        if (nodeId=="") nodeId = this.getRootId();
        if (typeof(this.eventFunc[sAct.toLowerCase()]) != "undefined" && this.eventFunc[sAct.toLowerCase()][0] != null){
            this.eventFunc[sAct.toLowerCase()][0].apply(window, [nodeId]);
        }
        else{
            switch(sAct.toLowerCase()){
            case this.eventName.ClickFolder:
            case this.eventName.ClickIcon:
                rtn = this.treeProcess(sAct, nodeId);
                break;
            case this.eventName.ClickLabel:
                rtn = this.treeProcess(sAct, nodeId);
                break;
            case this.eventName.Check:
                rtn = this.treeProcess(sAct, nodeId);
                break;
            case this.eventName.DblClick:
                break;
            case this.eventName.Mouseover:
                rtn = this.treeProcess(sAct, nodeId);
                break;
            case this.eventName.Mouseout:
                rtn = this.treeProcess(sAct, nodeId);
                break;
            case this.eventName.Blur:
            case this.eventName.Change:
                rtn = this.treeProcess(sAct, nodeId);
                break;
            case this.eventName.Focus:
                break;
            case this.eventName.Keydown:
                break;
            case this.eventName.Open:
                rtn = this.treeProcess(sAct, nodeId);
                break;
            case this.eventName.Close:
                rtn = this.treeProcess(sAct, nodeId);
                break;
            case this.eventName.Edit:
                rtn = this.treeProcess(sAct, nodeId);
                break;
            }
            if (this.eventFunc[sAct.toLowerCase()] && this.eventFunc[sAct.toLowerCase()][1] != null){
                this.eventFunc[sAct.toLowerCase()][1].apply(window, [nodeId]);
            }
            return rtn;
        }
    };

    // 최상위 프래임 객체
    this.getFrame = function(){return this.getDom(this.frameId);};

    // 최초의 루트 아이디
    this.getRootId = function(){return this.treeIdPath+"0";};

    // 노드 Depth 생성
    this.nodeDepth = function(sId){
        var rtn = new Array();
        sId = this.getNodeId(sId);
        if (sId != "") rtn[rtn.length] = sId;
        var i=0;
        do{
            if (this.nList[sId]) sId = this.nList[sId].pid.trim();
            else sId = "";
            if (sId != "") rtn[rtn.length] = sId;
        }while(sId != "")
        return rtn;
    }

    // 신규 노드 값 생성하기
    this.makeNewNodeId = function(pId, isChild){
        return this.treeIdPath + this.nodeKeySeq++;
    }

    // 초기값 설정후 기본 트리 그리기
    this.init = function(sFrame){
        var rootName;
        var rootFrame;
        this.frameId = sFrame;
        document.body.innerHTML += this.makeContext();
        document.body.innerHTML += this.makeProgressUI();
        rootFrame = this.getDom(sFrame);
        if (!rootFrame) {this.msgWin("기본 프래임이 없습니다.");return;};
        rootFrame.className = this.frameCss;
        rootFrame.innerHTML = this.makeTreeBody();
        this.treeProcess(this.eventName.Addnode);
        this.treeProcess(this.eventName.Add);
        rootFrame.style.padding=0;
        this.objectShow(rootFrame);

        rootName = this.getNodeName(sFrame);
        this.objectShow(this.getDom(rootName.Frame));

        rootName = this.getNodeName(this.getRootId());
        rootFrame = this.getDom(rootName.Frame);
        if (!this.rootVisible){
            rootFrame.style.paddingLeft = "0px";
            this.objectHide( this.getDom(rootName.Folder) );
            this.objectHide( this.getDom(rootName.Check) );
            this.objectHide( this.getDom(rootName.Icon) );
            this.objectHide( this.getDom(rootName.Label) );
            this.objectHide( this.getDom(rootName.Text) );
        }
        this.objectShow(rootFrame);
        
		// 20150803 추가 - chrome 에서 오류.
		var __userAgent = window.navigator.userAgent;
		if ( __userAgent.indexOf( "Chrome" ) != -1 && __userAgent.indexOf( "Safari" ) != -1) {
			this.getFrame().onselectstart = this.selectEnable;
		}		
        this.getFrame().ondragstart = function() { return false; };

        this.removeEvnetHandler(document, "mousedown", this.mouseDownHandler);
        this.addEventHandler(document, "mousedown", this.mouseDownHandler);
    };
    this.selectEnable = function(evt){
        var e = __AhnLabTreeSelfEvent[thisName].getEvent(evt);
        return (e.element.id.indexOf(__AhnLabTreeSelfEvent[thisName].nodeTail.textinput) > 0);
    };
    this.mouseDownHandler = function(evt){
        var e = __AhnLabTreeSelfEvent[thisName].getEvent(evt);
        if (e != null) {
            var actNodeId = __AhnLabTreeSelfEvent[thisName].getNodeId(e.element.id);
            var actNodeName = __AhnLabTreeSelfEvent[thisName].getNodeName(actNodeId);
            if (actNodeName.Label == e.element.id && e.btn == 2) {
                if (__AhnLabTreeSelfEvent[thisName].makeContextMenu(actNodeId)) {
                    __AhnLabTreeSelfEvent[thisName].contextMenuShow(e.mouseX, e.mouseY);
                }
            }
            else
                if (__AhnLabTreeSelfEvent[thisName].ContextId.Item != e.element.id) e = null;
        }
        if (e == null) {
            __AhnLabTreeSelfEvent[thisName].contextMenuForceHide();
        }
    };
}
